<?php
/**
 * implements hook_help()
 * Megjeleniti a module help informaciokat
 * @param unknown_type $path
 * @param unknown_type $arg
 * @return string
 */
function fz_form_help($path,$arg){
  $output = '';
  
  switch($path){
    case "admin/help/fz_form":
      break;
    case "admin/help#fz_form":
      $output = '<h3>' .t('About'). '</h3>';
      $path = drupal_get_path('module', 'fz_form') . '/fz_form.info';
      $info = drupal_parse_info_file($path);
      $output .= 'Author: <a href="http://www.fzolee.hu">Zoltan Fabian</a><br/>';
      $output .= t('version').': '.$info['version'].'<br/>';
      $output .= t('compiled').': '.date('Y.m.d',$info['datestamp']);
      $output .='<p>'.t("FZ Form: Nappali és esti jelentkezési lap a GSZC iskoláiba.").'</p>';
      $output .='<p>'.t('<a href="../../fz_form/jel" target="_blank">Új jelentkező</a>').'</p>';
      $output .='<p>'.l(t('More Help'),'admin/config/fz/fz_form').'</p>';
      break;
  }
  return $output;
}

/**
 *	implements hook_menu implementalasa
 */
function fz_form_menu(){
  $access= array('administer administration pages');
  
  $items = array();
  
  // kezdőoldal
  $items['admin/config/fz/fz_form'] = array(
      'title'            => 'FZ Form alapbeállítások',
      'description'      => 'Jelentkezési lap beállítások',
      'page callback'    => 'drupal_get_form',
      'page arguments'   => array('fz_form_settings'),
      'access arguments' => $access,
      'weight' => 1
  );
  
   $items['admin/config/fz/fz_form/makeusers'] = array(
      'title'            => 'Felhasználók létrehozása',
       'page arguments'   => array('fz_form_makeusers'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK,
  );

  //Jelentkezési lapok
  $items['admin/config/fz/fz_form/app'] = array(
      'title'           => 'Jelentkezések',
      'description'     => 'Jelentkezési lapok listája',
      'page callback'   => 'drupal_get_form',
      'page arguments'  => array('fz_form_app'),
      'access arguments'=> $access,
      'type'            => MENU_LOCAL_TASK,
      'weight'          => 3,
  );
  
 //A szakmák, az iskolák, a képzés indulása és formájának listája (Szerkeszthető?)
  $items['admin/config/fz/fz_form/conn']=array(
      'title'            => 'Oktatások / képzések kínálata',
      'description'      => 'A szakmák, az iskolák, az oktatás indulása és a formájának kapcsolata',
      'page arguments'   => array('fz_form_conn'),
      'access arguments' => $access,
      'type'             => MENU_LOCAL_TASK,
      'weight'           => 4,
  );
  
  // szakmák listája (Szerkeszthető?)
  $items['admin/config/fz/fz_form/prof'] = array(
      'title'            => 'Szakmák',
      'description'      => 'Szakmák listája',
      'page arguments'   => array('fz_form_prof'),
      'access arguments' => $access,
      'type'             => MENU_LOCAL_TASK,
      'weight'           => 6,
  );
 
  //Iskolák listája - szerkeszthető (?)
  $items['admin/config/fz/fz_form/school'] = array(
      'title'            => 'Iskolák',
      'description'      => 'Iskolák listája',
      'page callback'    => 'drupal_get_form',
      'page arguments'   => array('fz_form_school'),
      'access arguments' => $access,
      'type'             => MENU_LOCAL_TASK,
      'weight'           => 7,
  );
  
  //Iskolák callback menüpontjai
  $items['admin/config/fz/fz_form/school/load'] = array(
      'title'            => 'Iskola betöltése',
      'page arguments'   => array('fz_form_school_load'),
      'access arguments' => array('administer administration pages'),
      'type'             => MENU_CALLBACK
  );
  
  $items['admin/config/fz/fz_form/school/delete'] = array(
      'title'            => 'Iskola törlése',
      'page arguments'   => array('fz_form_school_delete'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  $items['admin/config/fz/fz_form/school/save'] = array(
      'title'            => 'Iskola mentése',
      'page arguments'   => array('fz_form_school_save'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  //Szakmák callback menupontjai
  $items['admin/config/fz/fz_form/prof/load'] = array(
      'title'            => 'Szakma betöltése',
      'page arguments'   => array('fz_form_prof_load'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  
  $items['admin/config/fz/fz_form/prof/delete'] = array(
      'title'            => 'Szakma törlése',
      'page arguments'   => array('fz_form_prof_delete'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  $items['admin/config/fz/fz_form/prof/save'] = array(
      'title'            => 'Szakma mentése',
      'page arguments'   => array('fz_form_prof_save'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  $items['admin/config/fz/fz_form/prof/export'] = array(
      'title'            => 'Szakmák exportja Excelbe',
      'page arguments'   => array('fz_form_prof_export'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  $items['admin/config/fz/fz_form/prof/import'] = array(
      'title'            => 'Szakmák importja Excelből',
      'page arguments'   => array('fz_form_prof_import'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );

  //szakmák, Iskolák, Indulások, Formák listája
  $items['admin/config/fz/fz_form/conn/load'] = array(
      'title'            => 'Kapcsolatok a szakmák, iskolák, oktatási időpontok és formátumok között',
      'page arguments'   => array('fz_form_conn_load'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );

  //Kapcsolatok törlése, ha lehet
  $items['admin/config/fz/fz_form/conn/delete'] = array(
      'title'            => 'Kapcsolatok törlése',
      'page arguments'   => array('fz_form_conn_delete'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );

  //Kapcsolatok mentése, vagy újak létrehozása
  $items['admin/config/fz/fz_form/conn/save'] = array(
      'title'            => 'Kapcsolatok mentése',
      'page arguments'   => array('fz_form_conn_save'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  
  //szakmák, Iskolák, Indulások, Formák listája
  $items['admin/config/fz/fz_form/app/load'] = array(
      'title'            => 'Kapcsolatok a szakmák, iskolák, oktatási időpontok és formátumok között',
      'page arguments'   => array('fz_form_app_load'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  //Kapcsolatok törlése, ha lehet
  $items['admin/config/fz/fz_form/app/delete'] = array(
      'title'            => 'Jelentkezések törlése',
      'page arguments'   => array('fz_form_app_delete'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  //Jelentkezések mentése, vagy újak létrehozása
  $items['admin/config/fz/fz_form/app/save'] = array(
      'title'            => 'Jelentkezések mentése',
      'page arguments'   => array('fz_form_app_save'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );
  
  //Jelentkezések exportálása
  $items['admin/config/fz/fz_form/app/export'] = array(
      'title'            => 'Jelentkezések exportja',
      'page arguments'   => array('fz_form_app_export'),
      'access arguments' => $access,
      'type'             => MENU_CALLBACK
  );

  //Jelentkezési lap megjelenítése anonymous user részére
  $items['fz_form/jel'] = array(
      'title'            => 'Jelentkezési lap',
      'description'      => 'Jelentkezési lap - multipage',
      'page callback'    => 'drupal_get_form',
      'page arguments'   => array('fz_form_jel'),
      'access arguments' => array("access content"),
      'type'             => MENU_CALLBACK
  );

  //Jelentkezési lap megjelenítése anonymous user részére
  $items['fz_form/elkuldve'] = array(
      'title'            => 'Jelentkezési lap kitöltve',
      'description'      => 'Jelentkezési lap kitöltve, az adatok elküldve',
      'page callback'    => 'fz_form_elkuldve',
      'page arguments'   => array(),
      'access arguments' => array("access content"),
      'type'             => MENU_CALLBACK
  );
  
  //Jelentkezési lap megjelenítése anonymous user részére
  $items['fz_form/jel/conn'] = array(
      'title'            => 'A Jelentkezési tábla adatok AJAX lekérdezése a Szakma oldal frissítéséhez',
      'description'      => 'A Jelentkezési tábla adatok AJAX lekérdezése a Szakma oldal frissítéséhez',
      'page callback'    => 'drupal_get_form',
      'page arguments'   => array('fz_form_jel_conn'),
      'access arguments' => array("access content"),
      'type'             => MENU_CALLBACK
  );
  
  $items['fz_form/confirm'] = array(
      'title'            => 'A jelentkezés megerősítése',
      'description'      => 'A jelentkezést meg kell erősíteni a böngészőben',
      'page callback'    => 'fz_form_confirm',
      'page arguments'   => array('fz_form_confirm'),
      'access arguments' => array("access content"),  //Frissíthetem a tartalmat
      'user_access'      => TRUE,
      'access_callback'  => TRUE,
      'type'             => MENU_CALLBACK
  );
  
  $items['fz_form/download'] =array(
      'title'            => 'A jelentkezésről előállított pdf fájl letöltése',
      'description'      => 'A letöltött pdf fájl bizonyítja jelentkezését',
      'page callback'    => 'fz_form_download',
      'page arguments'   => array('fz_form_download'),
      'access arguments' => array("access content"), //Megnézhetem a tartalmaz
      'user_access'      => TRUE,
      'access_callback'  => TRUE,
      'type'             => MENU_CALLBACK
  );
  
  $items['fz_form/view'] =array(
      'title'            => 'A jelentkezésről előállított pdf fájl megtekintése',
      'description'      => 'A letöltött pdf fájl bizonyítja jelentkezését',
      'page callback'    => 'fz_form_download',
      'page arguments'   => array('fz_form_view'),
      'access arguments' => array("access contents"), //Megnézhetem a tartalmaz
      'user_access'      => TRUE,
      'type'             => MENU_CALLBACK
  );
  
  return $items;
}

