<?php
/**
 * Kapcsolatok listája
 */
function fz_form_conn(){
  $path = drupal_get_path("module", "fz_form");
  drupal_add_css($path. "/css/fz_form.css","file");
  drupal_add_js($path . '/js/fz_form.js');
  $form = array();
    
  $form['conn_export'] = array(
      '#type'  => 'submit',
      '#title' => 'conn_export',
      '#name'  => 'conn_export',
      '#value' => 'Kínálat exportja (Excelbe)',
      '#submit'=> array('fz_form_conn_export'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  $form['conn_i'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Imort',
      '#collapsible' => FALSE,
  );
  
  $form['conn_i']['conn_importfile'] = array(
      '#type'              => 'managed_file',
      '#title'             => 'Válaszd ki a kínálati Excel file-t.',
      '#description'       => 'Csak xls és xlsx típusú Excel fájlokat lehet feltölteni. <br/>Ellenőrizzük a fájl szerkezetét és csak a hibátlan szerkezetű adatokat töltjük fel az adatbázisba.<br>\
      A táblázat oszlopai: okj, iskola, kezdes, forma, hidden<br/>Csak a bejelentkezett felhasználó iskolájának a kínálatát lehet feltölteni!',
      '#name'              => 'conn_imporfile',
      '#upload_location'   => 'public://'.variable_get('fz_form_upload',"fz_form_upload"),
      '#upload_validators' => array(
          'file_validate_extensions' => array("xls xlsx"),
          'file_validate_size'       => array(file_upload_max_size()),
      ),
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
      //      '#progress_indicator' =>'bar',
      // "#process"                     => array("fz_form_prof_importfile_process"),
  );
  
  $form['conn_i']['conn_import'] = array(
      '#type'  => 'submit',
      '#title' => 'conn_import',
      '#name'  => 'conn_import',
      '#value' => 'Kínálat importja (Excelből)',
      '#submit'=> array('fz_form_conn_import'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  
  $js = '$j(document).ready( function(){
  $j(document).ajaxComplete( function(e,xhr,settings){
    n = settings.url.search("/file/ajax/");
    if(n>0){
      var c = $j("span.file").length;
      if(c > 0 ){
        $j("input#edit-conn-import").removeAttr("disabled");
      }else{
        $j("input#edit-conn-import").attr("disabled","disabled");
      }
    }
  });
  $j("input#edit-conn-import").attr("disabled","disabled");
});';
  
  drupal_add_js($js,"inline");
  
  
  $header = array(
      'okj'    => array('data' => "OKJ"                , 'field'=> 's.OKJ'),
      'nev'    => array('data' => "Név"                , 'field'=> 'p.nev'),
      'iskola' => array('data' => "Iskola"             , 'field'=> 's.iskola'),
      'kezdes' => array('data' => "Az oktatás kezdése" , 'field'=> 's.kezdes'),
      'forma'  => array('data' => "Az oktatás formája" , 'field'=> 's.forma'),
      'hidden' => array('data' => "Nem látható"        , 'field'=> 's.hidden'),
  );

  $form['conn_item'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Keresés / szűrés',
      '#collapsible' => FALSE,
  );
  
  $selopt = array();
  foreach($header AS $i =>$row){
    $selopt[$i] = $row['data'];
  }
  
  $form['conn_item']['conn_sid'] =array(
      '#title'   => "Melyik mezőben keresel?",
      '#type'    => 'select',
      '#options' => $selopt,
      '#default_value' => isset($_POST['conn_sid'])? $_POST['conn_sid'] :'',
      '#description'   => 'Válassza ki a keresni kívánt mezőt!',
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );

  $form['conn_item']['conn_value'] =array(
      '#title'   => "A keresett érték",
      '#type'    => 'textfield',
      '#default_value' => isset($_POST['conn_value'])? $_POST['conn_value'] :'',
      '#description'   => 'A keresett érték',
      '#size'    => 32,
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );
  
  $form['conn_item']['conn_search'] =array(
      '#type'    => 'submit',
      '#title'   => "Szűrés",
      '#name'  => 'conn_search',
      '#value' => 'Szűrés',
      '#submit'=> array('fz_form_conn_search'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  $form['conn_item']['conn_reset'] = array(
      '#type'  => 'submit',
      '#title' => "Feltétel törlése",
      '#name'  => 'conn_reset',
      '#value' => "Feltétel törlése",
      '#submit'=> array('fz_form_conn_reset'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  
  $qry = db_select('fz_form_conn','s');
  $qry->join('fz_form_prof','p', "p.okj = s.okj");
  $qry->fields('s',array("id", "okj","iskola", "kezdes", "forma", "hidden"));
  $qry->fields('p', array('nev'));
  
  if($iskola = fz_form_user_iskola()){
    $qry->condition('iskola',$iskola,'=');
  }
  
  if(isset($_REQUEST['conn_search']) && isset($_REQUEST['conn_value']) ){
   $qry->condition($_REQUEST['conn_sid'],"%".$_REQUEST['conn_value']."%",'LIKE');
  }
  $tsort = $qry->extend('TableSort')->orderByHeader($header);
  $pager = $tsort->extend('PagerDefault')->limit(20);
      
  $rs = $pager->execute();
  
  $options = array();
  while ($row = $rs->fetchObject() ){
    $options[$row->id] = array(
        'okj'    => $row->okj,
        'nev'    => $row->nev,
        'iskola' => $row->iskola,
        'kezdes' => $row->kezdes,
        'forma'  => $row->forma,
        'hidden' => $row->hidden,
    );
  }
  
 $form['conn_table'] = array(
      '#title' => "Iskolák, szakmák, kezdés, forma táblázata",
      "#type" => 'tableselect',
      '#header' => $header,
      '#options' => $options,
      '#empty' => 'Nincsen kapcsolat a táblában',
      '#js_select property' => FALSE,
      '#multiple'=>FALSE,
      '#title_display' => "Iskolák és szakmák kapcsolat táblázata",
  );
  
  $form['pager'] = array(
      '#markup' => theme('pager'),
  );


  $form['conn_id'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Azonosító',
      '#description' => 'A rekord azonosítója',
      '#attributes'  =>  array('readonly' =>'readonly'),
      '#size'        => 10,
      '#maxlength'   => 10,
  );
  
  //Szakmák kezelése
  $rs = db_select('fz_form_prof','s')
        ->fields('s',array("okj","nev"))
        ->condition('hidden',1,'<')
        ->orderBy("okj")
        ->execute();
  
  $szakmak = $rs->fetchAll(PDO::FETCH_ASSOC);
  $OKJ_options = array();
  foreach($szakmak As $i =>$szakma){
    $OKJ_options[trim($szakma["okj"])] = trim($szakma["okj"])." - ". $szakma["nev"];
  }
  
  $form['conn_okj'] = array(
      '#type'        => 'select',
      '#title'       => 'OKJ',
      '#description' => 'A szakma azonosítója (OKJ)',
      '#options'     => $OKJ_options,
      '#default'     => ''
  );

  //Iskolák kezelése
  $rs = db_select('fz_form_school','s')
       ->fields('s',array("id","nev"))
       ->orderBy("id")
       ->execute();
  
  $iskolak = $rs->fetchAll(PDO::FETCH_ASSOC);
  
  $iskola_options = array();
  foreach($iskolak As $i => $iskola){
    $iskola_options[ $iskola["id"] ] = $iskola["id"].' - '.$iskola['nev'];
  }
    
  $form['conn_iskola'] = array(
      '#type'        => 'select',
      '#title'       => 'Iskola',
      '#description' => 'Az iskola azonosítójának kiválasztása',
      '#options'     => $iskola_options,
  );
      
  $opt = preg_split("/\n/", variable_get('fz_form_kezdes'));
  foreach($opt As $i){
    $i = trim($i);
    $optind[$i] =  $i;
  }
  
  $form['conn_kezdes'] = array(
      '#type'        => 'select',
      '#title'       => 'Az oktatás / képzés kezdése',
      '#options'     => $optind,
      '#description' => 'Az oktatás / képzés kezdése',
  );
  //
  $opt = preg_split("/\n/", variable_get('fz_form_forma'));
  foreach($opt As $i){
    $i = trim($i);
    $optforma[$i] = $i;
  }
  
  $form['conn_forma'] = array(
      '#type'        => 'select',
      '#title'       => 'Képzési formák',
      '#options'     => $optforma,
      '#description' => 'Az oktatási forma kiválasztása (nappali, esti, levelező, tanfolyam)',
  );
  
  $form['conn_hidden'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Rejtett a képzés',
      '#size'        => 2,
      '#maxlength'   => 2,
      '#description' => 'Ha 1 elrejtjük a képzést a jelentkezők elől, ha 0, akkor látható és kiválasztható',
      
  );
  
  $form['conn_submit'] = array(
      '#title' => 'conn_submit',
      '#name'  => 'conn_submit',
      '#value' => 'Az aktuális oktatási / képzési kínálat mentése',
      '#type'  => 'submit',
      '#submit'=> array('fz_form_conn_save'),
  );
  
  $form['conn_reset'] = array(
      '#type'  => 'submit',
      '#title' => 'Az űrlapról törli az adatokat',
      '#name'  => 'conn_reset',
      '#value' => 'Az űrlapról törli az adatokat',
      '#submit'=> array('fz_form_conn_reset'),
      '#limit_validation_errors' => array(),       // No validation.
  );

  $form['conn_delete'] = array(
      '#type'  => 'submit',
      '#title' => 'conn_delete',
      '#name'  => 'conn_delete',
      '#value' => t('A kiválasztott oktatási / képzési kínálat törlése'),
      '#submit'=> array('fz_form_conn_delete'),
  );
  
  return $form;
}

/**
 * Az űrlapról kitörli az adatokat
 * @param array $form
 * @param array $form_state
 */
function fz_form_conn_reset($form, &$form_state){
  $form_state['rebuild'] = False;
}

/*
 * Az aktuális kínálat rekordját AJAX hívásra visszadja
 */
function fz_form_conn_load(){
  $id = $_REQUEST["id"];
  if(!empty($id)){
    $rs = db_select('fz_form_conn','s')
          ->fields('s',array("id","iskola","okj", "kezdes", "forma", "hidden"))
          ->condition('id' , $id , '=' )
          ->execute();
    $row = $rs->fetchAssoc();
  }else{
    $row = array("id" => "unknown");
  }
  $json = json_encode($row);
  die($json);
}
/**
 * Kapcsolatok törlése
 * @param array $form
 * @param array $form_state
 */
function fz_form_conn_delete(&$form, &$form_state){
  $ok = False;
  $ok = db_query("DELETE FROM {fz_form_conn} WHERE id = :1", array(':1' => $form_state['values']['conn_id']) );
  if($ok){
    drupal_set_message(FZ_FORM_DEL_OK, "notice");
  }else{
    drupal_set_message(FZ_FORM_DEL_NEM_OK, "error");
  }
  $form_state['rebuild'] =TRUE;
}

function fz_form_conn_save(&$form, &$form_state){
  //  drupal_set_message('A kapcsolatok mentése fejlesztés alatt','warning');
  $ok = FALSE;
  $v     = $form_state['values'];
  unset($v["conn_submit"]);
  unset($v["conn_reset"]);
  unset($v["conn_delete"]);
  unset($v["form_build_id"]);
  unset($v["form_token"]);
  unset($v["form_id"]);
  $r=array();
  foreach($v AS $i => $e){
    $idx=substr($i,5);
    $r[$idx]  = $e;
  }
  
  if( !empty($r['id']) ) {
    // Frissítés
    $ok = drupal_write_record("fz_form_conn", $r, "id");
        
    if($ok == SAVED_UPDATED){
      drupal_set_message(FZ_FORM_SAVE_OK, "notice");
    }else{
      drupal_set_message(FZ_FORM_SAVE_NEM_OK,"error");
    }
  }else{
    //Új rekord
    //$ok = drupal_write_record("fz_form_conn", $v);
    if($ok == SAVED_NEW){
      drupal_set_message(FZ_FORM_NEW_OK, "notice");
    }else{
      drupal_set_message(FZ_FORM_NEW_NEM_OK, "error");
    }
  }
  $form_state['rebuild'] =TRUE;
}

/**
 * a szakmák exportálása
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_conn_export(&$form, &$form_state){
  global $user, $base_url;

  //$v = $form_state['values'];
  //fz_t($v);
  $qry = db_select("fz_form_conn","p")
       ->fields('p',array('id','iskola','okj','kezdes','forma','hidden'));
  if($iskola = fz_form_user_iskola()){
    $qry->condition('iskola',$iskola,'=');
  }
  $qry->orderBy('iskola')
      ->orderBy('okj');
  $rs = $qry->execute();

  //Excel létrehozása
  $iskola   = "";
  $filename = "Kinalat_".date("YmdHis").".xlsx";
  $p        = fz_form_file_path($iskola,$filename);
  $link     = $iskola.(!empty($iskola)? "/":"").$filename;
  $ok       = fzexcel_export($rs, $p,'Kínálat','Az FZ_FORM jelentkezési felület által létrehozott jelentkezések listája');

  if($ok){
    $url   = $base_url."/fz_form/download/?i=".$link;
    drupal_set_message('A iskolák szakmakínálata Excel fájl letölthető innen: <a href="'. $url.'">'.$filename.'</a>', "warning");
  }else{
    drupal_set_message("A szakmák listája Excel fájl nem jött létre itt: ". $p, "error");
  }
}

function fz_form_conn_import($form, &$form_state)
{
  
  $file = $form_state['complete form']['conn_importfile']['#file'];
  if(empty($file))
  {
    drupal_set_message("Nem töltött fel megfelelő szerkezetű Excel file-t","error");
    return;
  }
  
  if ($wrapper = file_stream_wrapper_get_instance_by_uri($file->uri)) {
    $path = $wrapper->realpath();
  }
  
  $xls = fzexcel_import($path, True);
  
  if (is_int($xls)){
    drupal_set_message("Az Excel fájl nem olvasható","error");
    return;
  }
  
  $table = $xls[0];
  if(count($table) < 1 ){
    drupal_set_message('Nincs adat az Excel fájl első munkalapján! Csak az első munkalapról tudjuk importálni az adatokat!',"error");
    return;
  }
  
  //Az Excel tábla szerkezetének ellenőrzése
  $schema = drupal_get_schema('fz_form_conn');
  
  $fields = array();
  unset($fields['id']);
  foreach($schema['fields'] AS $i => $e){
    $fields[] =$i;
  }
  
  $msg = "";
  foreach($fields AS $i){
    if (!array_key_exists($i,$table[0])){
      $msg .="'".$i."', ";
    }
  }
  
  if(!empty($msg)){
    drupal_set_message("Az Excel tábla szerkezete hibás! Az alábbi oszlopok hiányoznak: ".$msg,"error");
    return;
  }
  
  drupal_set_message("Az Excel fájlt betöltöttük","notice");
  
  //Melyik iskolára van joga
  $iskola = fz_form_user_iskola();
  
  //Beolvassuk a teljes prof táblát
  $qry = db_select("fz_form_conn","c");
  $qry->fields('c',array('id','iskola', 'okj','kezdes','forma','hidden'));
  if($iskola){
    $qry->condition('iskola',$iskola,'=');
  }
  $rs    = $qry->execute();
  $tabla = $rs->fetchallAssoc('id', PDO::FETCH_ASSOC);
  
  //Csak az új szakmákat adjuk hozzá
  $m = 0;
  
  //Végigmegyünk az Excel tábla sorain
  foreach($table AS $i => $row ){
    if($iskola){
      if($iskola != $row["iskola"])
        continue;
    }
  
    //Van-e megfelelő sor a táblában?
    $temp = $row;
    unset($temp['hidden']);
    unset($temp['id']);
    $talalat = fz_form_multisearch($tabla, $temp);

    //Ha van megfelelő sor a táblában, azt nem bántjuk
    if(count($talalat)>0){
      continue;
    }
    // Csak beszúrás, ha nincsen olyan OKJ
    unset($row['id']);
    drupal_write_record("fz_form_conn", $temp);   //Beszúrjuk az új rekordot
    drupal_set_message("Az új beszúrt kínálat azonosítója: ".$row['okj'].' | '.$row['iskola'].' | '.$row['kezdes'].' | '.$row['forma'],"notice");
    $m++;
  }
  drupal_set_message("Az oktatások / képzések kínálatának importálása az Excel fájlból megtörtént. Új rekord:".$m." db.", "warning");
}

function fz_form_conn_search($form, &$form_state){
  $form_state['rebuild'] =TRUE;
}