<?php
/**
 * Callback függvények
 */


/**
 * Jelentkezési lapot visszaigazolta
 */
function fz_form_confirm(){
  $q   = $_GET["q"];
  $q   = str_replace("fz_form/confirm/", "", $q);
  $sql = "SELECT * FROM {fz_form_app} WHERE confirm = :1";
  $qry = db_query($sql,array(":1" => $q) );
  $db  = $qry->rowCount();
  
  if($db < 1){
    $msg  = FZ_FORM_NOAPP;
    $mode = "error";
  } else if ($db>1){
    $msg  = FZ_FORM_TOOMUCH;
    $mode = "error";
  }else{
    $rs  = $qry->fetchAssoc();
    $id  = $rs['id'];
    if($rs['status'] == FZ_FORM_STATUS_CONFIRM){
      $msg  = FZ_FORM_NOCONFIRM;
      $mode = "error";
    }else{
      db_query("update {fz_form_app} SET status = '".FZ_FORM_STATUS_CONFIRM."' WHERE id= :id", array(":id" => $id));
      $msg  = FZ_FORM_CONFIRMED;
      $mode = "notice";
    }
  }
  
  $goto="fz_form/jel";
  drupal_set_message($msg,$mode);
  drupal_goto($goto);
}

/**
 * A megadott pdf-et vagy más fájlt letöltő függvény callback függvény
 */
function fz_form_download(){
  
  if(isset($_GET['i']) ) {
    $url = $_GET['i'];
  }else{
     $url = "/";
  }
  if( strpos($url, "://") !== false || strpos($url, "..") !== false ) {
 	  drupal_not_found();
 	  die();
  }
    
  $type     = pathinfo($url,PATHINFO_EXTENSION);
  $folder   = pathinfo($url,PATHINFO_DIRNAME);
  $filename = pathinfo($url, PATHINFO_BASENAME);
  
  //Content type és root folder
  switch($type){
    case 'pdf':
      $folder = variable_get("fz_form_pdf",FZ_FORM_DOC)."/".$folder;
      $type   = "application/pdf";
      break;
    case 'jpg'  :
    case 'jpeg' :
      $type   = "image/jpeg";
      break;
    case 'png'  :
      $type   = "image/png";
    case 'doc'  :
      $type   = "application/msword";
      break;
    case 'docx':
      $type   = "application/vnd.openxmlformats-officedocument.wordprocessingml.document";
      break;
      break;
    case 'xls' :
      $folder = variable_get("fz_form_excel",FZ_FORM_EXCEL);
      $type = "application/vnd.ms-excel";
      break;
    case 'xlsx':
      $folder = variable_get("fz_form_excel",FZ_FORM_EXCEL);
      $type = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
      break;
    default:
      drupal_set_message("Az Ön által megadott letölthető file nem található!","warning");
    //  drupal_goto("/");
    fz_t("Nincsen rewrite");
      die();
   //   break;
  }
 
  $w = file_stream_wrapper_get_instance_by_uri("public://".$folder);
  $p = str_replace("\\", "/" , $w->realpath())."/";
  
  //headers
  $size     = filesize($p.$filename);
  
  header("Cache-Control:max-age");
  header("Content-disposition: inline; filename=".$filename );
  header("Content-length: ".$size);
  header("Content-type: ".$type);
  $c = file_get_contents($p.$filename);
  echo $c;
  die();
}

/**
 * Generálja az könyvtárnevet az Excel táblához
 * @param string $fname
 * @param string $iskola (Ha iskolánként akarjuk kezelni az exportot) - továbbfejlesztési céllal
 */
function fz_form_file_path( $iskola, $filename){
  $w = file_stream_wrapper_get_instance_by_uri("public://".variable_get("fz_form_excel",FZ_FORM_EXCEL).(!empty($iskola)?"/".$iskola :""));
  $p = str_replace("\\", "/" , $w->realpath());
  
  if( !is_dir($p) ){
    mkdir($p,0777,True);
  }
  $p .= "/".$filename;
  return $p;
}

/**
 * Két dimenizós táblában keresünk
 * @param array $array
 * @param array $pairs
 */
function fz_form_multisearch(array $data, array $ertekek){
  $found = array();
  foreach ($data as $j => $row) {
    $talalat = 0;
    foreach ($ertekek as $oszlop => $ertek) {
      if (array_key_exists($oszlop, $row) && $row[$oszlop] == $ertek) {
        $talalat++;
      }
    }
    if ($talalat == count($ertekek)) {
      $found[$j] = $row;
    }
  }
  
  return $found;
}
/**
 * A feltöltött dokumentumok átmásolása a megfelelő helyre
 * @param unknown $v
 */
function fz_form_move_files(&$v){
  global $base_url;
  $iskola   = $v['iskola'];
  $confirm  = $v['confirm'];
  
  $to    = 'public://'.variable_get("fz_form_doc",FZ_FORM_DOC)."/".$iskola."/".$confirm;
  for($i=1;$i<4;$i++){
    $u = $v['upload'.$i];
    if($u !=0 ){
      if(!is_dir($to)){
        mkdir($to,0777,True);
      }
      $file    = file_load($u);
      $newfile = file_move($file, $to, FILE_EXISTS_REPLACE);
      if(!$newfile){
        drupal_set_message('A feltöltött "'.$file->filename.'" nevű dokumentumot nem sikerült a helyére mozgatni!<br/>Kérjük, hogy a beiratkozáskor hozza magával!',"error");
        $link ='--';
      }else{
        $link = variable_get("fz_form_doc",FZ_FORM_DOC)."/".$iskola."/".$confirm."/".$newfile->filename;
        $link  = $base_url."/fz_form/download/?i=".$link;
      }
      $v['upload'.$i] = $link;
    }
  }
}