<?php

/**
 * Szakma kiválasztása
 * @param unknown $v
 * @return array() $form;
 */
function fz_form_szakma(&$form_state){
 // $v        = $form_state["storedvalues"][1];
  $teszt    = variable_get("fz_form_teszt",False);
  $readonly = array('readonly' =>'readonly');

  drupal_set_title("A tanulandó szakma választása");
  
  $form['ido'] = array(
      '#type'         => 'textfield',
      '#title'        => 'A jelentkezés időpontja',
      '#description ' => 'A jelentkezés időpontja',
      '#attributes'   => $readonly,
      '#size'         => 20,
      '#maxlength'    => 20,
      '#required'     => 'required',
      '#default_value'=> $form_state["values"]['ido']
  );
  //Szakmák kezelése
  $rs = db_select('fz_form_prof','s')
  ->fields('s',array("okj","nev","belepes"))
  ->condition('hidden',1,'<')
  ->orderBy("okj")
  ->execute();
   
  $szakmak = $rs->fetchAll(PDO::FETCH_ASSOC);
  $OKJ_options = array();
  foreach($szakmak As $i =>$szakma){
    $OKJ_options[$szakma["okj"]] = $szakma["okj"]." - ". $szakma["nev"]." - (".$szakma['belepes']." után)";
  }
   
  // Kitöltendő akkor itt select van
  $form['okj'] = array(
      '#type'        => 'select',
      '#title'       => 'OKJ',
      '#description' => 'A szakma OKJ azonosítója és elnevezése',
      '#options'     => $OKJ_options,
      '#required'    => 'required',
  );

  $field = "okj";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //
  $form ['szakma'] = array(
      '#type'         => 'textfield',
      '#title'        => 'A szakma neve',
      '#description'  => 'A szakma elnevezése',
      '#size'         => 64,
      '#maxlength'    => 64,
      '#default_value'=> '',
      '#attributes'   => array(
          'readonly' => 'readonly',
          'style' => 'display: none;'
      ),
  );

  $field = "szakma";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Kezdés
  $opt = preg_split("/\n/", variable_get('fz_form_kezdes'));
  foreach($opt As $i){
    $i = trim($i);
    $optkezd[$i] = $i;
  }
  
  $form['kezdes'] = array(
      '#type'        => 'select',
      '#title'       => 'Az oktatás / képzés indulása',
      '#options'     => $optkezd,
      '#description' => 'Az oktatási indulása',
      '#required'    => 'required',
  );
  $field = "kezdes";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Képzési forma
  $opt = preg_split("/\n/", variable_get('fz_form_forma'));
  foreach($opt As $i){
    $i = trim($i);
    $optforma[$i] =$i;
  }

  //Képzési forma
  $form['forma'] = array(
      '#type'        => 'select',
      '#title'       => 'Képzési formák',
      '#options'     => $optforma,
      '#description' => 'Az oktatási forma kiválasztása (nappali, esti, levelező, tanfolyam)',
      '#required'    => 'required',
  );
  $field = "forma";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Képzési idő
  $opthossz = array("teljes" => "teljes", "beszámítással" => "beszámításos");
  $kepzido  = "Általában az oktatás / képzés teljes hosszúságú. A rövidítés akkor lehet, ha van szakirányú korábbi végzettség<br>";
  $kepzido .= "- Szakirányú érettségi után a megfelelő szakmát 2 év helyett 1 év alatt végezheti el.<br>";
  $kepzido .= "- Érettségi célú: van legalább befejezett 10. évfolyam => 2 év alatt szerezhet érettségit";

  $form['kepzido'] = array(
      '#type'        => 'select',
      '#title'       => 'A képzési idő hossza',
      '#description' => $kepzido ,
      '#options'     => $opthossz,
      '#required'    => 'required',
  );
  $field = "kepzido";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Iskolák kezelése
  
  $q = db_select('fz_form_school','s');
  $q->join('fz_form_conn','c','s.id = c.iskola');
  $q->fields('s',array("id","nev"));
  $q->orderBy("s.id");
  $rs=$q->execute();

  $iskolak = $rs->fetchAll(PDO::FETCH_ASSOC);

  $iskola_options = array();
  foreach($iskolak As $i => $iskola){
    $iskola_options[ $iskola["id"] ] = $iskola['nev'];
  }
/*
  $form['iskola'] = array(
      '#type'        => 'select',
      '#title'       => 'Iskola',
      '#description' => 'Az iskola azonosítójának kiválasztása',
      '#options'     => $iskola_options,
      '#required'   => 'required'
  );
  */
  $form['iskola'] = array(
      '#type'         => 'textfield',
    //  '#title'        => 'Iskola',
    //  '#description'  => 'Az iskola azonosítójának kiválasztása',
      '#default_value'=> 'SZILY',
      '#required'     => 'required',
      '#attributes'   => array(
          'readonly'  => 'readonly',
          'style' => 'display: none;'
      ),
  );
  
  
  
  $field = "iskola";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }
  
  $out = array();
 // fz_form_felvett_letszamok($out, '','','','');
 /*
  *  $form['letszam'] = array(
      '#type'         => 'textfield',
    //  '#title'        => 'foglalt  /  összes  / szabad hely',
      '#size'         => 5,
      '#maxlength'    => 5,
      '#default_value'=> $out['letszam'],
      '#attributes'   => array(
          'readonly' => 'readonly',
          'style'    => 'display:inline;'
      ),
//      '#prefix'       => '<div class="display: inline;">',
      '#suffix'       => ''
  );
  */
//  fz_form_max_letszam($out);
 /*
  $form['maxletszam'] = array(
      '#type'         => 'textfield',
      '#title'        => '',
      '#size'         => 5,
      '#maxlength'    => 5,
      '#default_value'=> $out['max'],
      '#attributes'   => array(
          'readonly' => 'readonly',
          'class'    => array('fz_form_inline_input'),
      ),
  );
  */
  /*
  $form['szabad'] = array(
      '#type'         => 'textfield',
      '#title'        => '',
      '#size'         => 5,
      '#maxlength'    => 5,
      '#default_value'=> ($out['max']-$out['letszam']),
      '#attributes'   => array(
          'readonly' => 'readonly',
          'class'    => array('fz_form_inline_input'),
      ),
      '#prefix'       => '',
  //    '#suffix'       => '</div>'
  );
  */
  fz_form_add_submit_buttons($form, $form_state);
  return $form;
}

function fz_form_szakma_alter(&$form, &$form_state, $form_id) {
  // There will already be some validate handlers added so you need to add to the
  // array rather than overwrite it.
  $form['#validate'][] = 'fz_form_szakma_validate';
}

//Adatok valdálása
function fz_form_szakma_validate($form, &$form_state){
  $teszt = variable_get("fz_form_teszt",False);

  $v = $form_state['values'];
  
  if(empty($v['name'])){
    form_set_error('name',"A név mező nem lehet üres");
  }

  if(filter_var($v['email'], FILTER_VALIDATE_EMAIL ) ) {
    form_set_error('email', "Az email cím nem érvényes");
  }
}


/**
 * A beviteli oldalon visszahívásos függvény: fz_form/jel/conn
 */
function fz_form_jel_conn(){
  $jel    = isset($_REQUEST['jel'])    ? $_REQUEST['jel']    : "";
  $okj    = isset($_REQUEST["okj"])    ? $_REQUEST["okj"]    : "";
  $forma  = isset($_REQUEST['forma'])  ? $_REQUEST["forma"  ]: "";
  $kezdes = isset($_REQUEST['kezdes']) ? $_REQUEST["kezdes"] : "";
  $iskola = isset($_REQUEST['iskola']) ? $_REQUEST["iskola"] : "";

  $qry = db_select("fz_form_conn",'c')->fields("c",array('id',"okj","kezdes","forma", 'iskola','letszam'));
  $qry->condition('hidden' , 1, "<");

  if(!empty($okj))    $qry->condition('okj'   , $okj,   "=");
  if(!empty($forma))  $qry->condition('forma' , $forma, "=");
  if(!empty($kezdes)) $qry->condition('kezdes', $kezdes,"=");
  if(!empty($iskola)) $qry->condition('iskola', $iskola,"=");

  $rs = $qry->execute();
  
  $_okjcond    = "'-1'";
  $_iskolacond = "'-1'";
  $formak      = '<option value="" >- Választás -</option>'."\n";
  $kezdesek    = '<option value="" >- Választás -</option>'."\n";
  
  $out = array();
  $out['maxletszam'] = 0;
  //Végigmegyek a kapcsolótábla eredményein
  while($row = $rs->fetchObject()){
    //A szakmák szűkítése
    if ( preg_match("/o/",$jel) && 0 == preg_match("|".$row->okj."|i"  , $_okjcond))   $_okjcond    .= ",'".$row->okj."'";

    //A lehetséges indulások tömbjét töltöm fel
    if ( preg_match("/k/",$jel) && 0 == preg_match("|".$row->kezdes."|i", $kezdesek))  $kezdesek .= '<option value="'.trim($row->kezdes).'">'.$row->kezdes.'</option>'."\n";
    
    //A képzési formák tömbjét töltöm fel
    if ( preg_match("/f/",$jel) && 0 == preg_match("|".$row->forma."|i" , $formak))    $formak   .= '<option value="'.trim($row->forma).'">'.$row->forma.'</option>'."\n";
    //Az iskolák lekérdezéséhez készítek SQL
    if ( preg_match("/i/",$jel) &&  0 == preg_match("|".$row->iskola."|i", $_iskolacond)) $_iskolacond .= ",'".$row->iskola."'";
    
    $out['maxletszam'] += (int)$row->letszam;
  }

  fz_form_felvett_letszamok($out, $okj,$forma, $kezdes, $iskola);
    
  //A szakma kiválasztása a listából, majd a JSON tömb legyártása
  if(preg_match("/o/",$jel)){
    $sql     = 'SELECT okj, nev, belepes FROM {fz_form_prof} WHERE okj IN ('.$_okjcond.') ORDER BY okj';
    $rs      = db_query($sql);
    $szakmak = $rs->fetchAll(PDO::FETCH_ASSOC);
    $okjk    = "";
    foreach($szakmak As $i => $szakma){
      $okjk .= '<option value="'.$szakma['okj'].'">'.$szakma["okj"].' - '. $szakma["nev"].' - '.$szakma['belepes'].'</options>'."\n";
    }
    $out["okjk"] = $okjk;
  }

  //Kezdések
  if(preg_match("/k/",$jel)){
    $out["kezdesek"] = $kezdesek;
  }

  //képzési formák
  if(preg_match("/f/",$jel)){
    $out["formak"] = $formak;
  }
  
  //Iskolák kiválogatása
  //Az iskolák felsorolása
  if(preg_match("/i/",$jel)){
    $sql1    = "SELECT id, nev FROM {fz_form_school} WHERE id IN (".$_iskolacond.") ORDER BY id";
    $rs1     = db_query($sql1);

    $schools = $rs1->fetchAll(PDO::FETCH_ASSOC);
    $iskolak = "";
    foreach($schools As $i => $iskola){
      $iskolak .= '<option value="'.$iskola['id'].'">'.$iskola['id'].' - '.$iskola['nev'].'</option>'."\n";
    }
    $out["iskolak"] = $iskolak;
  }

  //Kimenet json kódolása
  $json = json_encode($out);
  die($json);
}

function fz_form_felvett_letszamok(&$out, $okj='', $forma='', $kezdes='',$iskola=''){
  //Eddig jelentkezettek száma
  $q = db_select('fz_form_app','p')->fields('p',array('id'));
  if(!empty($okj))    $q->condition('okj'   , $okj,   "=");
  if(!empty($forma))  $q->condition('forma' , $forma, "=");
  if(!empty($kezdes)) $q->condition('kezdes', $kezdes,"=");
  if(!empty($iskola)) $q->condition('iskola', $iskola,"=");
  $rs             = $q->execute();
  $out['letszam'] = $rs->rowCount();
}

function fz_form_max_letszam(&$out){
  $qry = db_select("fz_form_conn",'c')->fields("c",array('id'));
  $qry->addExpression("sum(letszam)","ossz");
  $qry->condition('hidden' , 1, "<");
  $max = $qry->execute()->fetchAssoc();
  $out['max'] = $max['ossz'];
}