<?php
/**
 * Személyes adatok űrlapja
 * @param array() $v - az éppen aktuális adatok listája
 */
function fz_form_szemelyes(&$form_state){
  $teszt = variable_get("fz_form_teszt",False);
  $t     = $form_state["values"]["ido"];

  drupal_set_title("Személyes adatok");

  $form  = array();

  //Név
  $form['nev'] = array(
      '#type'         => 'textfield',
      '#title'        => 'A jelentkező neve',
      '#description'  => 'A jelentkező neve',
      '#size'         => 40,
      '#maxlength'    => 64,
      '#required'     => 'required',
      '#default_value'=> $teszt ? "Teszt Kázmér".$t:""
  );
  $field = "nev";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  // Születési név
  $form['szulnev'] = array(
      '#type'         => 'textfield',
      '#title'        => 'A jelentkező születési neve',
      '#description'  => 'A jelentkező neve',
      '#size'         => 40,
      '#maxlength'    => 64,
      '#default_value'=> $teszt ? "Teszt Abigél ".$t:""
  );

  $field = "szulnev";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Állampolgárság
  $form['allamp'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Állampolgárság',
      '#description'   => 'A jelentkező állampolgársága.',
      '#size'          => 40,
      '#maxlength'     => 40,
      '#required'      => 'required',
      '#default_value' => $teszt ? "magyar":""
  );

  $field = "allamp";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Oktatási azonosító
  $form['oktazon'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Oktatási azonosító',
      '#description'   => '7-essel kezdődő 11 jegyű szám. Csak 1995 óta létezik.',
      '#size'          => 11,
      '#maxlength'     => 11,
      '#default_value' => $teszt ? "72345678901" : ""
  );
  $field    = "oktazon";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Születési hely
  $form['szulhely'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Születési hely',
      '#description'   => 'A jelentkező születési helye',
      '#size'          => 40,
      '#maxlength'     => 40,
      '#required'      => 'required',
      '#default_value' => $teszt ? "Bátonyterenye":""
  );
  $field    = "szulhely";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  // Születési idő
  $form['szulido'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Születési idő',
      '#description'   => 'ÉÉÉÉ.HH.NN formátumban megadva',
      '#size'          => 11,
      '#maxlength'     => 11,
      '#required'      => 'required',
      '#default_value' => $teszt ? "1900.01.01":""
  );
  $field    = "szulido";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Anyja neve
  $form['anyjaneve'] = array(
      '#type'         => 'textfield',
      '#title'        => 'A jelentkező anyjának neve',
      '#description'  => 'A jelentkező édesanyjának születéskori neve',
      '#size'         => 40,
      '#maxlength'    => 64,
      '#required'     => 'required',
      '#default_value'=> $teszt ? "Teszt Eleonóra Mama Drakuluj":""
  );
  $field    = "anyjaneve";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Cím
  $form['cim'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Lakcíme',
      '#description'  => 'Állandó, bejelentett lakcíme',
      '#size'         => 40,
      '#maxlength'    => 128,
      '#required'     => 'required',
      '#default_value'=> $teszt ? "1111 Budapest, Kárpátalja utca 999.":""
  );
  $field    = "cim";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Tartózkodási hely
  $form['tartcim'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Tartózkodási helyének címe (ha van)',
      '#description'  => 'Ha a jelentkező nem a bejelentett lakcímén tartózkodik huzamosabb ideig életvitelszerűen',
      '#size'         => 40,
      '#maxlength'    => 128,
      '#default_value'=> $teszt ? "1111 Budapest, Kárpátalja utca 998.":""
  );

  $field    = "tartcim";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  // Telefonszáma
  $form['tel'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Telefonszáma',
      '#description'   => 'Olyan telefonszámot kérünk megadni, amelyen a jelentkezőt el lehet érni (városi, vagy mobil)',
      '#size'          => 40,
      '#maxlength'     => 40,
      '#required'      => 'required',
      '#default_value' => $teszt ? "+36 30 123 4567":""
  );

  $field    = "tel";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Email címe
  $form['email'] = array(
      '#type'          => 'textfield',
      '#title'         => 'E-mail',
      '#description'   => 'Valós emailcímet adjon meg, hogy a jelentkezési lapról visszaküldött visszaigazoló meailt el tudjuk küldeni.',
      '#size'          => 40,
      '#maxlength'     => 40,
      '#required'      => 'required',
      '#default_value' => $teszt ? "fzolinet@gmail.com":""
  );

  $field    = "email";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //TAJ kártya száma
  $form['taj'] = array(
      '#type'          => 'textfield',
      '#title'         => 'Társadalombiztosítási szám',
      '#description'   => 'TAJ szám. 9 jegyű. Ezt használják az egészségügyi intézményekben is.',
      '#size'          => 11,
      '#maxlength'     => 11,
      '#default_value' => $teszt ? "123 456 789":""
  );
  $field    = "taj";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  fz_form_add_submit_buttons($form, $form_state);

  return $form;
}
