<?php

/**
 * Korábbi adatok bevitelének űrlapja
 * @param unknown $form_state
 * @return string[][]|number[][]
 */
function fz_form_korabbi(&$form_state){
  $v     = $form_state["values"];
  $teszt = variable_get("fz_form_teszt",False);
  $t     = date(" Y.m.d. H:t:s");
  drupal_set_title("Korábbi szakmák / végzettségek");

  $form  = array();

  //Legmagasabb iskolai végzettsége
  $form['iskvegz'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Legmagasabb iskolai végzettsége',
      '#description'  => "A jelentkezéshez szükséges lehet egy iskolai végzettség meglétére:".
      "<ul><li>a 33 és 34-es szakmákhoz szükséges 8 általános iskola</li>".
      "<li>az 54 és 55-ös szakmákhoz szükséges az érettségi megléte</li>".
      "<li>A szakmunkások érettségi célú oktatásához szakmunkás bizonyítvány kell</li>".
      "<li>a 'ráépülő' szakmák esetén kell egy alapszakma, ami szakmánként más és más</li></ul>",
      '#size'         => 40,
      '#maxlength'    => 40,
      '#required'     => 'required',
      '#default_value'=> $teszt ? "8 általános iskola":""
  );
  $field    = "iskvegz";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  //Tanult idegen nyelv
  $form['nyelv'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Tanult idegen nyelv',
      '#description'  => 'Akkor szükséges beírni, ha <strong>egy bizonyos idegen nyelvet akar tanulni</strong> (angol, német, stb...)',
      '#size'         => 40,
      '#maxlength'    => 40,
      '#default_value'=> $teszt ? "angol":""
  );
  $field    = "nyelv";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item1'] = array(
      '#type'   => 'fieldset',
      '#title'  => '<b>Korábbi első szakképesítés</b>',
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE,
  );
  
  //Első szakképesítés száma
  $form['item1']['kepokj1'] = array(
      '#type'         => 'textfield',
      '#title'        => 'OKJ azonosítója',
      '#description'  => "OKJ szakképesítés száma",
      '#size'         => 20,
      '#maxlength'    => 20,
      '#default_value'=> $teszt ? "33 123 45678":"",
  );
  $field    = "kepokj1";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item1']['kepnev1'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Elnevezése',
      '#description'  => 'A korábban megszerzett első OKJ szakképesítés elnevezése',
      '#size'         => 40,
      '#maxlength'    => 40,
      '#default_value'=> $teszt ? "Valami szakma":"",
  );
  $field    = "kepnev1";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }


  //Eklső állami finanszírozású képzés
  $form['item1']['kepallam1'] = array(
      '#type'         => 'checkbox',
      '#title'        => 'Jelölje be, ha a korábbi első szakképesítés állami finanszírozású volt!',
      '#description'  => 'A korábban megszerzett első OKJ szakképesítés állami támogatású volt',
      '#default_value'=> $teszt ? "1":"",
  );
  $field    = "kepallam1";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }
  
  $form['item2'] = array(
      '#type'        => 'fieldset',
      '#title'       => '<b>Korábbi második szakképesítés</b>',
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE,
  );
  //
  $form['item2']['kepokj2'] = array(
      '#type'         => 'textfield',
      '#title'        => 'OKJ azonosítója',
      '#description'  => "OKJ szakképesítés száma",
      '#size'         => 20,
      '#maxlength'    => 20,
      '#default_value'=> $teszt ? "33 123 45678":"",
  );
  $field    = "kepokj2";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item2']['kepnev2'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Elnevezése',
      '#description'  => 'A korábban megszerzett második OKJ szakképesítés elnevezése',
      '#size'         => 40,
      '#maxlength'    => 40,
      '#default_value'=> $teszt ? "Valami szakma":"",
  );
  $field    = 'kepnev2';
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item2']['kepallam2'] = array(
      '#type'         => 'checkbox',
      '#title'        => 'A korábbi második szakképesítés állami finanszírozású volt',
      '#description'  => 'A korábban megszerzett második OKJ szakképesítés állami támogatású volt',
      '#default_value'=> $teszt ? "1":"",
  );
  $field    = 'kepallam2';
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item3'] = array(
      '#type'        => 'fieldset',
      '#title'       => '<b>Korábbi harmadik szakképesítés</b>',
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE
  );
  $form['item3']['kepokj3'] = array(
      '#type'         => 'textfield',
      '#title'        => 'OKJ azonosítója',
      '#description'  => "OKJ szakképesítés száma",
      '#size'         => 20,
      '#maxlength'    => 20,
      '#default_value'=> $teszt ? "54 123 45678":"",
  );
  $field    = "kepokj3";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item3']['kepnev3'] = array(
      '#type'         => 'textfield',
      '#title'        => 'Elnevezése',
      '#description'  => 'A korábban megszerzett harmadik  OKJ szakképesítés elnevezése',
      '#size'         => 40,
      '#maxlength'    => 40,
      '#default_value'=> $teszt ? "Technikusi szakma":"",
  );
  $field    = "kepnev3";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item3']['kepallam3'] = array(
      '#type'         => 'checkbox',
      '#title'        => 'A korábbi második szakképesítés állami finanszírozású volt',
      '#description'  => 'A korábban megszerzett harmadik  OKJ szakképesítés állami támogatású volt',
      '#default_value'=> $teszt ? "1":"",
  );
  $field    = "kepallam3";
  if(isset($form_state["storedvalues"][$form_state['step']][$field])){
    $form[$field]['#default_value'] = $form_state["storedvalues"][$form_state['step']][$field];
  }

  $form['item4'] = array(
      '#type'        => 'fieldset',
      '#title'       => '<b>A jelentkezéshez tartozó dokumentumok képének feltöltése</b>',
      '#description' => '<ul><li>Legfeljebb három dokumentum tölthető fel.</li><li>A feltöltött dokumentumok az alábbiak lehetnek: pdf, jpg, png, doc, docx.</li><li>A dokumentumok letörölhetőek amíg a jelentkezés nem végleges!</li><li>A dokumentumokat csak a jelentkezéssel kapcsolatban használjuk és kérésre megsemmisítjük!</li></ul>',
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE
  );
  
  for($i=1;$i<4;$i++){
    $form['item4']['upload'.$i] = array(
      '#type'              => 'managed_file',
      '#title'             => $i.'. dokumentum',
      '#description'       => 'A feltölthető dokumentum típus: pdf, jpg, png, gif, doc docx.',
      '#name'              => 'impordoc',
      '#upload_location'   => 'public://'.variable_get('fz_form_upload',"fz_form_upload"),
      '#upload_validators' => array(
          'file_validate_extensions' => array("pdf jpg jpeg png gif doc docx"),
          'file_validate_size'       => array(file_upload_max_size()),
      ),
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
      '#attributes' => array('multiple' => 'multiple'),
      
      //      '#progress_indicator' =>'bar',
      // "#process"                     => array("fz_form_prof_importfile_process"),
    );
  }
  //Elfogadandó állítás
  $form['valodi'] = array(
      '#type'         => 'checkbox',
      '#title'        => '<span class="form-required" title="Szükséges mező."><b>A fenti adatok a valóságnak megfelelnek</b> *</span>',
      '#description'  => '<span class="form-required" title="Szükséges mező.">Büntetőjogi felelősségem tudatában kijelentem, hogy a fenti adatok a valóságnak megfelelnek, azokat beiratkozáskor hiteles iratokkal bizonyítani tudom!</span>',
      '#required'     => 'required',
      '#default_value'=> $teszt ? "0":"",
  );

  fz_form_add_submit_buttons($form, $form_state);
  return $form;
}
