<?php

/**
 *  hook_mail() - implementation
 * @param unknown $key
 * @param array $message
 * @param array $params
 */
function fz_form_mail($key, &$message, $params){
  $message['subject'] = FZ_FORM_SUBJECT;
  $message['body'][] = $params['message'];
}
/**
 * Visszaigazoló emailt küld a megadott email címre
 * @param array() $v - az emailben lévő dolgok adatai
 * @param int $time - aktuális idő
 * @param unknown $id - az utoljára felvett jelentkezés id-je
 * @param string -
 */
function fz_form_send_mail($v, $time, $id, $schoolemailfrom=''){

  $iskola = $v["iskola"];
  
  $q = db_query("SELECT id, email, user, nev, tel FROM {fz_form_school} WHERE id = :iskola", array(":iskola"=> $iskola));
  $rs = $q->fetchAssoc();

  // Specify 'to' and 'from' addresses.
  if(!empty($schoolemailfrom)){
    $to = $rs["user"]." <".$rs["email"].">";    //Címzett az iskola
    $from = $schoolemailfrom;                   //Feladó a jelentkeztetési rendszer
  }else{
    $from = $rs["user"]." <".$rs["email"].">";  //Feladó az iskola
    $to   = $v["email"];                        //Címzett a jelentkező
  }
  //
  
  //Teszt esetén a címzett én vagyok!!!!
 
 if(0 < variable_get("fz_form_teszt")){
    $to = "fzolinet@gmail.com";
  }

  // A levél törzse
  $html = file_get_contents(drupal_get_path("module", "fz_form")."/template/mailhtml.tpl");
  $html = str_replace("{iskola}",$rs["nev"],$html);

  $sch = drupal_get_schema_unprocessed("fz_form","fz_form_app");
  $rows ="";
  foreach($v AS $i => $e){
    $rows .= $sch['fields'][$i]['description'];
    $rows .= " => ";
    $rows .= $e;
    $rows .= "\n";
  }
  
  $html = str_replace("{rows}", $rows     , $html);
  $html = str_replace("{tel}" , $rs['tel'], $html);
  $html = str_replace("{date}", $time     , $html);

  $link = $_SERVER["REQUEST_SCHEME"]."://".$_SERVER["SERVER_NAME"].dirname($_SERVER["PHP_SELF"])."/fz_form/confirm/".$v["confirm"];
  $html = str_replace("{link}",$link,$html);
   
  // Beállítjuk a HTMl mai lküldésének a paramétereit
  $ms = variable_get('mail_system');
  if( !isset($ms['fz_form'])){
    variable_set('mail_system', array('default-system' => 'DefaultMailSystem', 'fz_form' => 'FZFormMailSystem'));
  }
 
  $module            = 'fz_form';
  $key               = 'application_form';
  $language          = language_default();
  $params['message'] = $html;
  
  $res['result'] = false;
  $res = drupal_mail($module, $key, $to, $language, $params, $from, TRUE);
  if ($res['result'] == TRUE) {
    $res = db_query("update {fz_form_app} SET status='email' WHERE id= :id", array(":id" => $id));
    $v['status'] = FZ_FORM_STATUS_EMAIL;
    if(!empty($schoolemailfrom)) {
      $msgemail = array('msg' =>'Az iskolát emailben értesítettük az Ön jelentkezéséről!','mode'=>"warning");
    }else{
      $msgemail = array('msg' =>'Önnek elküldtünk egy emailt a megadott email címre. A levélben megadott linkre kattintva véglegesítheti jelentkezését','mode'=>"warning");
    }
    
  }
  else {
    if(!empty($schoolemailfrom)) {
      $msgemail = array('msg'=> 'Sajnos az iskolának küldött emailt nem tudtuk kézbesíteni, de a jelentkezési rendszer adatbázisában a jelentkezési adatait rögzítettük.','mode'=>'error');
    }else{
      $msgemail = array('msg'=> 'Sajnos az Önnek elküldött levelet nem tudtuk kézbesíteni. Nyomtassa ki vagy mentse le a pdf-ben megjelenő jelentkezési lapot.','mode'=>'error');
    }
    
  }
  return $msgemail;
}
/**
 * Visszaigazoló levél küldése a beiratkozásról
 * @param unknown $v
 * @param unknown $time
 * @param unknown $id - A jelentkezés Id-je
 * @param string $schoolemailfrom
 */

function fz_form_felveve_mail($v, $time, $id, $schoolemailfrom=''){
  $q = db_query("SELECT id, email, user, nev, tel FROM {fz_form_school} WHERE id = :iskola", array(":iskola"=> $v->iskola));
  $rs = $q->fetchAssoc();
  // Specify 'to' and 'from' addresses.
  if(!empty($schoolemailfrom)){
    $to = $rs["user"]." <".$rs["email"].">";    //Címzett az iskola    ;
    $from = $schoolemailfrom;                   //Feladó a jelentkeztetési rendszer
  }else{
    $from = $rs["user"]." <".$rs["email"].">";  //Feladó az iskola
    $to   = $v->email;                        //Címzett a jelentkező
  }
  
  //Teszt esetén a címzett én vagyok!!!!
  if(0 < variable_get("fz_form_teszt")){
    $to = "fzolinet@gmail.com";
  }
  
  // A levél törzse
  $html = file_get_contents(drupal_get_path("module", "fz_form")."/template/beiratkozas.tpl");
  $html = str_replace("{iskola}",$rs["nev"],$html);
  $html = str_replace("{nev}"    , $v->nev    , $html);
  $html = str_replace("{okj}"    , $v->okj    , $html);
  $html = str_replace("{szakma}" , $v->szakma , $html);
  $html = str_replace("{kezdes}" , $v->kezdes , $html);
  $html = str_replace("{forma}"  , $v->forma  , $html);
  $html = str_replace("{kepzido}", $v->kepzido, $html);
  $html = str_replace("{tel}"    , $rs["tel"] , $html);
  $html = str_replace("{date}"   , $time      , $html);
  
  // Beállítjuk a HTMl mai lküldésének a paramétereit
  $ms = variable_get('mail_system');
  if( !isset($ms['fz_form'])){
    variable_set('mail_system', array('default-system' => 'DefaultMailSystem', 'fz_form' => 'FZFormMailSystem'));
  }
 
  $module            = 'fz_form';
  $key               = 'application_form';
  $language          = language_default();
  $params['message'] = $html;
  $res['result'] = false;
  $res = drupal_mail($module, $key, $to, $language, $params, $from, TRUE);
  if ($res['result'] == TRUE) {
    $res = db_query("update {fz_form_app} SET status='".FZ_FORM_STATUS_OK."' WHERE id= :id", array(":id" => $id));
    $v->status = FZ_FORM_STATUS_OK;
    $msgemail = array('msg' => $v->nev." számára a levelet elküldtük",'mode' =>'warning');
  }else {
    $msgemail = array('msg'=> $v->nev.' számára a levelet nem tudtuk kézbesíteni!','mode'=>'error');
  }
  return $msgemail;
}

/**
 * HTML levelek küldéséhez szükséges
 * @author Rendszergazda
 *
 */
class FZFormMailSystem implements MailSystemInterface {
  /**
   * Concatenate and wrap the e-mail body for plain-text mails.
   *
   * @param array $message
   *   A message array, as described in hook_mail_alter().
   *
   * @return array
   *   The formatted $message.
   */
  public function format(array $message) {
    $message['body'] = implode("\n\n", $message['body']);
    return $message;
  }
  
  /**
   * Send an e-mail message, using Drupal variables and default settings.
   *
   * @see http://php.net/manual/en/function.mail.php
   * @see drupal_mail()
   *
   * @param array $message
   *   A message array, as described in hook_mail_alter().
   *
   * @return bool
   *   TRUE if the mail was successfully accepted, otherwise FALSE.
   */
  public function mail(array $message) {
    $mimeheaders = array();
    foreach ($message['headers'] as $name => $value) {
      $mimeheaders[] = $name . ': ' . mime_header_encode($value);
    }
    $line_endings = variable_get('mail_line_endings', MAIL_LINE_ENDINGS);
    return mail(
        $message['to'],
        mime_header_encode($message['subject']),
        // Note: e-mail uses CRLF for line-endings. PHP's API requires LF
        // on Unix and CRLF on Windows. Drupal automatically guesses the
        // line-ending format appropriate for your system. If you need to
        // override this, adjust $conf['mail_line_endings'] in settings.php.
        preg_replace('@\r?\n@', $line_endings, $message['body']),
        // For headers, PHP's API suggests that we use CRLF normally,
        // but some MTAs incorrectly replace LF with CRLF. See #234403.
        implode("\n", $mimeheaders)
        );
  }
}
