<?php

/**
 * PDF fájlt készít a jelentkezési adatokból
 * @param unknown $v
 * @param unknown $time
 */
function fz_form_pdf($v, $time, $id)
{

  $tcpdf = str_replace("\\","/",drupal_get_path('module',"FZ_FORM") ) . "/lib/tcpdf/tcpdf.php";
  
  //require_once($path."/examples/tcpdf_include.php");
  require_once($tcpdf);
  $pdf = new tcpdf('P', 'mm', 'A4', TRUE, 'UTF-8', FALSE);
  $pdf->SetCreator(PDF_CREATOR);
  $pdf->SetAuthor('Fábián Zoltán');
  $pdf->SetTitle(FZ_FORM_SUBJECT);
  $pdf->SetSubject(FZ_FORM_SUBJECT);
  $pdf->setHeaderFont(array('freesans','',12));
  $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
  $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
  $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
  $pdf->SetFont('freesans','',10,'',true);

  $iskola = $v["iskola"];
  $q = db_query("SELECT id, email, user, nev, cim, tel FROM {fz_form_school} WHERE id = :iskola", array(":iskola"=> $iskola));
  $rs = $q->fetchAssoc();

  $pdf->setHeaderData("","", $rs["nev"],$rs["cim"].", Tel: ".$rs["tel"].", E-mail: ".$rs['email']);
  $pdf->setMargins(25.4, 25.4);
  $pdf->setPrintHeader(True);
  $pdf->AddPage();

  $html = file_get_contents(drupal_get_path("module", "fz_form")."/template/pdfhtml.tpl");

  $html = str_replace("{iskola}",$rs["nev"],$html);
  $html = str_replace("{title}",FZ_FORM_SUBJECT, $html);
  $html = str_replace("{email}",$rs['email'], $html);
  
  $sch = drupal_get_schema_unprocessed("fz_form","fz_form_app");
  $confirm = '';
  $rows ="";
  foreach($v AS $i => $e){
    $rows .= $sch['fields'][$i]['description'];
    $rows .= " => ";
    $rows .= $e;
    if($i == "confirm") $confirm = $e;
    $rows .= "<br/>\n";
  }
  
  $link = $_SERVER["REQUEST_SCHEME"]."://".$_SERVER["SERVER_NAME"].dirname($_SERVER["PHP_SELF"])."/fz_form/confirm/".$confirm;
  $html = str_replace("{link}",$link,$html);
  
  $html = str_replace("{rows}",$rows,$html);
  $html = str_replace("{tel}", $rs['tel'], $html);
  $html = str_replace("{date}", $time, $html);

  $pdf->writeHTML($html, true, false, false, false,"");
  
  $uri         = 'public://'.variable_get("fz_form_pdf",FZ_FORM_DOC).'/'.$iskola;
  $stream      = file_stream_wrapper_get_instance_by_uri($uri);
    //
  $p = str_replace("\\", "/" , DRUPAL_ROOT . "/" . $stream->getdirectoryPath()."/" . file_uri_target($uri));
    
  if( !is_dir($p) ){
    mkdir($p,0777,True);
  }
  $filename = '/Jelentkezes_'.$v["confirm"].'.pdf';
  $target = "F"; //File mentés
  
  if(strpos($target, 'F') !== False ){
    $pdf->Output('file://'.$p.'/'. $filename, 'F');
  }
  return $iskola.$filename;
 }

