<?php
/**
 * Szakmákkal kapcsolatos függvények
 * Fábián Zoltán 2016.03.27.
 */
function fz_form_prof(){
  $path = drupal_get_path("module", "fz_form");
  drupal_add_css($path. "/css/fz_form.css","file");
  drupal_add_js($path . '/js/fz_form.js');
  
  $form = array();
  $form['#attributes'] = array('enctype' => "multipart/form-data");

  $form['prof_export'] = array(
      '#type'  => 'submit',
      '#title' => 'prof_export',
      '#name'  => 'prof_export',
      '#value' => 'Szakmák exportja (Excelbe)',
      '#limit_validation_errors' => array(),       // No validation.
      '#submit'=> array('fz_form_prof_export'),
  );
  
  $form['prof_item'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Import',
      '#collapsible' => FALSE,
  );
  $form['prof_item']['prof_importfile'] = array(
      '#type'              => 'managed_file',
      '#title'             => 'Válaszd ki a megfelelő formátumú Excel file- bt',
      '#description'       => 'Csak xls és xlsx típusú Excel fájlokat lehet feltölteni. Az importálás során ellenőrizzük a fájl szerkezetét és csak a hibátlan szerkezetű adatokat töltjük fel az adatbázisba.',
      '#name'              => 'prof_imporfile',
      '#upload_location'   => 'public://'.variable_get('fz_form_upload',"fz_form_upload"),
      '#upload_validators' => array(
         'file_validate_extensions' => array("xls xlsx"),
         'file_validate_size'       => array(file_upload_max_size()),
      ),
//      '#progress_indicator' =>'bar',
     // "#process"                     => array("fz_form_prof_importfile_process"),
  );
  
  $form['prof_item']['prof_importmod'] = array(
      '#type'  => 'checkbox',
      '#title' => '<strong>Az Excel táblából való importálás módja</strong>',
      '#description' => '<strong>Kijelölve</strong>: Felülírja az azonos szakmát / <strong>Nincs kijelölve</strong>: Csak az új szakmákat írja be',
  );
  
  $form['prof_item']['prof_import'] = array(
      '#type'  => 'submit',
      '#title' => 'prof_import',
      '#name'  => 'prof_import',
      '#value' => 'Szakmák importja (Excelből)',
      '#submit'=> array('fz_form_prof_import'),
      '#limit_validation_errors' => array(),       // No validation.
  );

  
  $js = '$j(document).ready( function(){
  $j(document).ajaxComplete( function(e,xhr,settings){
    n = settings.url.search("/file/ajax/");
    if(n>0){
      var c = $j("span.file").length;
      if(c > 0 ){
        $j("input#edit-prof-import").removeAttr("disabled");
      }else{
        $j("input#edit-prof-import").attr("disabled","disabled");
      }
    }
  });
  $j("input#edit-prof-import").attr("disabled","disabled");
});';
  
  drupal_add_js($js,"inline");
  $header = array(
      'okj'     => array('data' => "OKJ"              , 'field'=> 's.okj', "id" =>"okj"),
      'nev'     => array('data' => "Név"              , 'field'=> 's.nev', "id" => "nev"),
      'belepes' => array('data' => "Belépés feltétele", 'field'=> 's.belepes'),
      'ido'     => array('data' => "Tanítási Idő"     , 'field'=> 's.ido'),
      'oraszam' => array('data' => "Óraszám"          , 'field'=> 's.oraszam'),
      'elmgyak' => array('data' => "Elmélet / gyakorlat aránya", 'field'=> 's.elmgyak'),
      'web'     => array('data' => "Leírás"           , 'field'=> 's.web'),
      'hidden'  => array('data' => "Rejtett"          , 'field'=> 's.hidden'),
  );
  
  $form['prof_i2'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Keresés / szűrés',
      '#collapsible' => FALSE,
  );
  
  $selopt = array();
  foreach($header AS $i =>$row){
    $selopt[$i] = $row['data'];
  }
  
  $form['prof_i2']['prof_sid'] =array(
      '#title'   => "Melyik mezőben keresel?",
      '#type'    => 'select',
      '#options' => $selopt,
      '#default_value' => isset($_POST['prof_sid'])? $_POST['prof_sid'] :'',
      '#description'   => 'Válassza ki a keresni kívánt mezőt!',
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );
  
  $form['prof_i2']['prof_value'] =array(
      '#title'   => "A keresett érték",
      '#type'    => 'textfield',
      '#default_value' => isset($_POST['prof_value'])? $_POST['prof_value'] :'',
      '#description'   => 'A keresett érték',
      '#size'    => 32,
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );
  
  $form['prof_i2']['prof_search'] =array(
      '#type'    => 'submit',
      '#title'   => "Szűrés",
      '#name'    => 'prof_search',
      '#value'   => 'Szűrés',
      '#submit'  => array('fz_form_prof_search'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  $form['prof_i2']['prof_reset'] = array(
      '#type'  => 'submit',
      '#title' => "Feltétel törlése",
      '#name'  => 'prof_reset',
      '#value' => 'Feltétel törlése',
      '#submit'=> array('fz_form_prof_reset'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  
  $qry = db_select('fz_form_prof','s')
        ->fields('s',array("okj","nev","belepes","ido", "oraszam", "elmgyak", "web", "hidden"));
  
  if(isset($_REQUEST['prof_search']) && isset($_REQUEST['prof_value']) ){
    $qry->condition($_REQUEST['prof_sid'],"%".$_REQUEST['prof_value']."%",'LIKE');
  }
  $tsort = $qry->extend("TableSort")->orderByHeader($header);
  $pager = $tsort->extend('PagerDefault')->limit(20);
  $rs    = $pager->execute();
  
 
  $options = array();
  
  while ($row = $rs->fetchObject() ){
    $options[$row->okj] = array(
        'okj'     => $row->okj,
        'nev'     => $row->nev,
        'belepes' => $row->belepes,
        'ido'     => $row->ido,
        'oraszam' => $row->oraszam,
        'elmgyak' => $row->elmgyak,
        'web'     => '<a href="'.$row->web.'" target="_blank">'.$row->web.'</a>',
        'hidden'  => ($row->hidden==1 ? "rejtett" : ""),
    );
  }
  
  $form['prof_table'] = array(
      '#title'              => "Szakmák táblázata",
      "#type"               => 'tableselect',
      '#header'             => $header,
      '#options'            => $options,
      '#empty'              => 'Nincs szakma a táblázatban',
      '#js_select property' => FALSE,
      '#multiple'           => FALSE,
      '#title_display'      => "Szakmák táblázata",
      '#attributes'    => array("id"=>"proftable"),
  );
  
  $form['pager'] = array(
      '#markup' => theme('pager'),
  );
   
  
  $form['prof_okj'] = array(
      '#type'        => 'textfield',
      '#title'       => 'OKJ',
      '#description' => 'A szakma azonosítója',
      '#required'    => 'required',
      '#size'        => 20,
      '#maxlength'   => 20,
  );
  
  $form['prof_nev'] = array(
      '#type'        => 'textfield',
      '#title'       => 'A szakma elnevezése',
      '#description' => 'A szakma elnevezése',
      '#required'    => 'required',
      '#size'        => 60,
      '#maxlength'   => 60,
  );
  $form['prof_belepes'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Az osztályba való belépés feltétele',
      '#description' => 'Az osztályba való belépés feltétele',
      '#size'        => 120,
      '#maxlength'   => 120,
  );
  $form['prof_ido'] = array(
      '#type'       => 'textfield',
      '#title'       => 'Tanítási idő hossza',
      '#description' => 'Tanítási idő hossza nappalin. <br>Szakközépiskolai esti oktatás esetén lerövidülhet a 3 év => 2 évre<br>
      Beszámítás esetén a 2 év => 1 évre',
      '#size'        => 20,
      '#maxlength'   => 20,
  );
  
    
  $form['prof_oraszam'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Óraszám',
      '#description' => 'Óraszám nappali oktatás esetén <br> esti oktatás esetén 50%',
      '#size'        => 20,
      '#maxlength'   => 20,
  );
  
  $form['prof_elmgyak'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Elmélet és Gyakorlat aránya',
      '#description' => 'Elmélet és Gyakorlat aránya, általában: 40% / 60% vagy 30% / 60%',
      '#size'        => 20,
      '#maxlength'   => 20,
  );
  
  $form['prof_web'] = array(
      '#type'        => 'textfield',
      '#title'       => 'A szakma leírása az interneten',
      '#description' => 'A szakma leírása az interneten',
      '#size'        => 40,
      '#maxlength'   => 128,
  );
  
  $form['prof_hidden'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Nem jelenik meg',
      '#description' => 'A képzésre nem lehet jelentkezni (a jelentkezési űrlapon nem jelenik meg)',
      '#size'        => 5,
  );
  
  $form['prof_submit'] = array(
      '#type'  => 'submit',
      '#title' => 'prof_submit',
      '#name'  => 'prof_submit',
      '#value' => 'A szakma mentése',
      '#submit'=> array('fz_form_prof_save'),
  );
  
  $form['prof_reset'] = array(
      '#type'  => 'submit',
      '#title' => 'Az űrlapról törli az adatokat',
      '#name'  => 'prof_reset',
      '#value' => 'Az űrlapról törli az adatokat',
      '#limit_validation_errors' => array(),       // No validation.
      '#submit'=> array('fz_form_prof_reset'),
  );
  
  $form['prof_delete'] = array(
      '#type'      => 'submit',
      '#title'     => 'prof_delete',
      '#name'      => 'prof_delete',
      '#value'     => 'A kiválasztott szakma törlése',
      '#submit'    => array('fz_form_prof_delete'),
  );
  return $form;
}


/**
 * Reseteli az űrlapot
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_reset($form, &$form_state){
  $form_state['rebuild'] = False;
}

/*
 * Egy rekord betöltése a szakmákba
 */
function fz_form_prof_load(){
  $id = $_REQUEST["id"];
  if(!empty($id)){
    $rs = db_select('fz_form_prof','s')
    ->fields('s',array("okj","nev", "belepes","ido","oraszam", "elmgyak", "web","hidden"))
    ->condition('okj' , $id , '=' )
    ->execute();
    $row = $rs->fetchAssoc();
  }else{
    $row = array("ID" => "unknown");
  }
    
  $json = json_encode($row);
  die($json);
}

/**
 * Egy szakma törlése
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_delete(&$form, &$form_state){
  $v  = $form_state['values'];
  
  $db1 = db_select('fz_form_app',"s")
  ->fields('s',array('szakma'))
  ->condition('szakma',$v['prof_okj'],"=")
  ->execute();

  $err ="";
  if($db1->rowCount() > 0){
    $err .= "A szakmát nem lehet törölni, mert van ilyen szakma a jelentkezések között megjelölve!";
  }
 
  $db2 = db_select('fz_form_conn',"s")
  ->fields('s',array('okj'))
  ->condition('okj',$v['prof_okj'],"=")
  ->execute();
  
  if($db2->rowCount()>0){
    if(!empty($err)) $err .= "<br/>";
    $err .= "A szakmát nem lehet törölni, mert van meghirdetett oktatása / képzése!";
  }
  
  if(!empty($err)){
    $err = "Az szakma neve, száma: ". $v['prof_okj']." - ". $v['prof_nev']."<br>".$err;
    drupal_set_message($err,"error");
    return;
  }

  $db = db_delete("fz_form_prof")
  ->condition('okj',$v['prof_okj'],'=')
  ->execute();
  
  if($db>0){
    drupal_set_message($v['prof_okj']." - ". $v['prof_nev'].': A szakmát töröltük!',"warning");
  }
}
/**
 * A szakmák mentése
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_save($form, $form_state){
  $v     = $form_state['values'];
  
  if(empty($v['prof_nev'])){
    drupal_set_message("Nem lehet üres a szakma elnevezése!","error");
    return ;
  }
  
  $row = array(
      'okj'     => $v['prof_okj'],
      'nev'     => $v['prof_nev'],
      'belepes' => $v['prof_belepes'],
      'ido    ' => $v['prof_ido'],
      'oraszam' => empty($v['prof_oraszam']) ? 0 : (int)($v['prof_oraszam']),
      'elmgyak' => $v['prof_elmgyak'],
      'web'     => $v['prof_web'],
      'hidden'  => empty($v['prof_hidden']) ? 0 : (int)($v['prof_hidden']),
  );
  
  $rs = db_select ("fz_form_prof","s")
        ->fields("s",array("okj"))
        ->condition('okj',$v['prof_okj'],"=")
        ->execute();
  $db = $rs->rowCount();
  
  if($db==1){   //Update
    $dbnum = db_update("fz_form_prof")
            ->fields($row)
            ->condition('okj',$v['prof_okj'],"=")
            ->execute();
    
    if($dbnum >0){
      drupal_set_message( $v['prof_okj']." - ". $v['prof_nev'] .': "A szakma adatai frissültek', "notice" );
    }else{
      drupal_set_message( $v['prof_okj']." - ". $v['prof_nev'] .': A szakma adatai nem lehetett frissíteni!', "error" );
    }
  } else{
    $ok = db_insert("fz_form_prof")
    ->fields($row)
    ->execute();
    if($ok)
      drupal_set_message( $v['prof_okj']." - ". $v['prof_nev'] .": Az új szakma létrejött'", "notice");
    else
      drupal_set_message( $v['prof_okj']." - ". $v['prof_nev'] .": Az új szakma létrehozásánál hiba történt.", "warning");
  }
  
  $form['prof_table']['#default_value']= $row['okj'];
  $form_state['rebuild'] =TRUE;
}

/**
 * a szakmák exportálása
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_export(&$form, &$form_state){
  global $user, $base_url;

  $rs = db_select("fz_form_prof","p")
     ->fields('p',array('okj','nev','ido','oraszam','elmgyak','web','hidden'))
     ->orderBy('okj')
     ->execute();

  // Excel létrehozása
  $iskola = "";
  $filename = "Prof_".date("YmdHis").".xlsx";
  $p        = fz_form_file_path($iskola,$filename);
  $link     = $iskola.(!empty($iskola)? "/":"").$filename;
  $ok = fzexcel_export($rs, $p, 'Szakmák listája.','Az FZ_FORM jelentkezési felület által tárolt szakmák listája' );
  if($ok){
    $url   = $base_url."/fz_form/download/?i=".$link;
    drupal_set_message('Az iskolák szakmáinak kínálata elkészült. Az Excel file letölthető innen: <a href="'. $url.'">'.$filename.'</a>', "warning");
  }else{
    drupal_set_message("A szakmák listája Excel fájl nem jött létre itt: ". $p, "error");
  }
}
/**
 *
 * @param unknown $element
 * @param unknown $form_state
 * @param unknown $form
 */
function fz_form_prof_importfile_process($element, &$form_state, $form){
  $element = file_managed_file_process($element, $form_state, $form);
  //$element['upload_button']['#access'] = FALSE;
  return $element;
}
/**
 * A szakmák importálása
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_import($form, &$form_state){
  $file = $form_state['complete form']['prof_importfile']['#file'];
  if(empty($file)){
    drupal_set_message("Nem töltött fel megfelelő szerkezetű Excel file-t","error");
    return;
  }
  
  if ($wrapper = file_stream_wrapper_get_instance_by_uri($file->uri)) {
    $path = $wrapper->realpath();
  }
  $xls = fzexcel_import($path, True);
  
  if (is_int($xls)){
    drupal_set_message("Az Excel fájl nem olvasható","error");
    return;
  }
  
  $table = $xls[0];
  if(count($table) < 1 ){
    drupal_set_message('Nincs adat az Excel fájl első munkalapján! Csak az első munkalapról tudjuk importálni az adatokat!',"error");
    return;
  }
  
  //Az Excel tábla szerkezetének ellenőrzése
  $schema = drupal_get_schema('fz_form_prof');
  $fields = array();
  foreach($schema['fields'] AS $i => $e){
    $fields[] =$i;
  }
  $msg = "";
  foreach($fields AS $i){
    if (!array_key_exists($i,$table[0])){
      $msg .="'".$i."', ";
    }
  }
  if(!empty($msg)){
    drupal_set_message("Az Excel táblának a szerkezete hibás! Az alábbi oszlopok hiányoznak: ".$msg,"error");
    return;
  }
  
  drupal_set_message("Az Excel fájlt betöltöttük","notice");
  
  //Beolvassuk a teljes prof táblát
  $rs = db_select("fz_form_prof","p")
  ->fields('p',array('okj'))
  ->execute();
  
  //Az okj-ból kivesszük a szóközöket és a kötőjeleket, hogy egyértelmű legyen az összehasonlítás
  $col = $rs->fetchCol(0);
  $coltrim = array();
  for($i=0; $i<count($col);$i++){
    $coltrim[$i] = str_replace(array(' ','-'),"",$col[$i]);
  }
  
  // 1: felülírás, 0: csak az új sorokat írja be
  $mode = $form_state['complete form']['prof_importmod']['#value']==1? TRUE: FALSE;
  //Csak az új szakmákat adjuk hozzá
  $u = $m = 0;
  //Végigmegyünk az Excel tábla sorain
  foreach($table AS $i => $row ){
    $okj = str_replace(array(' ','-'),"",$row["okj"]);
    
    //Van-e olyan OKJ a táblában?
    $idx = array_search($okj, $coltrim);
    
    // Csak beszúrás, ha nincsen olyan OKJ
    if($idx === FALSE){
      drupal_write_record("fz_form_prof", $row);   //Beszúrjuk az új rekordot
      drupal_set_message("Az új beszúrt szakma azponosítója: ".$row['okj'],"notice");
      $u++;
    }
    //Felülírás, ha az üzemmód megengedi
    else{
      if($mode){
        $row['okj'] = $col[$idx]; //Visszaírjuk az eredeti indexet
        drupal_write_record("fz_form_prof",$row,"okj");
        drupal_set_message("A frissített szakma azonosítója: ".$row['okj']." ".$row['nev'],"notice");
        $m++;
      }
    }
  }
  drupal_set_message("A szakmák importálása Excel fájlból megtörtént. Új rekord:".$u." db, módosítva:".$m." db.", "warning");
}

/**
 * A szakmák közötti keresés
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_prof_search($form, &$form_state){
  $form_state['rebuild'] =TRUE;
}