<?php
/**
 * Iskolák kezelésével kapcsolatos függvények
 * Fábián Zoltán 2016
 */
function fz_form_school(){
  global $user;
  $path = drupal_get_path("module", "fz_form");
  drupal_add_css($path. "/css/fz_form.css","file");
  drupal_add_js($path . '/js/fz_form.js');
  $form = array();
  $header = array(
      'id'    => array('data' => "Azonosító"  , 'field'=> 's.id'),
      'nev'   => array('data' => "Név"        , 'field'=> 's.nev','id' => 'nev'),
      'user'  => array('data' => "Felhasz."   , 'field'=> 's.user'),
      'pwd'   => array('data' => "Jelszó"     , 'field'=> 's.user'),
      'cim'   => array('data' => "Cím"        , 'field'=> 's.cim','id' => 'cim'),
      'tel'   => array('data' => "Telefon"    , 'field'=> 's.tel'),
      'email' => array('data' => "E-mail"     , 'field'=> 's.email'),
      'web'   => array('data' => "Honlap"     , 'field'=> 's.web'),
  );
  
  $form['school_item'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Keresés / szűrés',
      '#collapsible' => FALSE,
  );
  
  $selopt = array();
  foreach($header AS $i =>$row){
    $selopt[$i] = $row['data'];
  }
  
  $form['school_item']['school_sid'] =array(
      '#title'   => "Melyik mezőben keresel?",
      '#type'    => 'select',
      '#options' => $selopt,
      '#default_value' => isset($_POST['school_sid'])? $_POST['school_sid'] :'',
      '#description'   => 'Válassza ki a keresni kívánt mezőt!',
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );
  
  $form['school_item']['school_value'] =array(
      '#title'   => "A keresett érték",
      '#type'    => 'textfield',
      '#default_value' => isset($_POST['school_value'])? $_POST['school_value'] :'',
      '#description'   => 'A keresett érték',
      '#size'    => 32,
      '#prefix'  => '<div style="float: left;">',
      '#suffix'  => '</div>',
  );
  
  $form['school_item']['school_search'] =array(
      '#type'    => 'submit',
      '#title'   => "Szűrés",
      '#name'    => 'school_search',
      '#value'   => 'Szűrés',
      '#submit'  => array('fz_form_school_search'),
      '#limit_validation_errors' => array(),       // No validation.
  );
  $form['school_item']['school_reset'] = array(
      '#type'  => 'submit',
      '#title' => "Feltétel törlése",
      '#name'  => 'school_reset',
      '#value' => 'Feltétel törlése',
      '#submit'=> array('fz_form_school_reset'),
      '#limit_validation_errors' => array(),       // No validation.
  );

  $qry = db_select('fz_form_school','s')
       ->fields('s',array("id","nev","user", "pwd","cim", "tel", "email", "web"));
  
  if($iskola = fz_form_user_iskola()){
    $qry->condition('id',$iskola,"=");
  }
  
  if(isset($_REQUEST['school_search']) && isset($_REQUEST['school_value']) ){
    $qry->condition($_REQUEST['school_sid'],"%".$_REQUEST['school_value']."%",'LIKE');
  }
  
  $tsort = $qry->extend("TableSort")->orderByHeader($header);
  $pager = $tsort->extend('PagerDefault')->limit(20);
  $rs    = $pager->execute();
  
  $options = array();
  $rowcount = $rs->rowCount();
  $r["id"] = $r["nev"] = $r["user"] = $r["pwd"]= $r["cim"] = $r["tel"] = $r["email"] = $r["web"] ='';
  while ($row = $rs->fetchObject() ){
    $options[$row->id] = array(
        'id'    => $row->id,
        'nev'   => $row->nev,
        'user'  => $row->user,
        'pwd'   => $row->pwd,
        'cim'   => $row->cim,
        'tel'   => $row->tel,
        'email' => $row->email,
        'web'   => '<a href="'.$row->web.'" target="_blank">'.$row->web.'</a>',
    );
    $r["id"]    = $row->id;
    $r["nev"]   = $row->nev;
    $r["user"]  = $row->user;
    $r["pwd"]   = (empty($row->pwd) ? $row->user."123" : $row->pwd);
    $r["cim"]   = $row->cim;
    $r["tel"]   = $row->tel;
    $r["email"] = $row->email;
    $r["web"]   = $row->web;
  }
  
  $form['school_table'] = array(
      '#title'         => "Iskolák táblázata",
      "#type"          => 'tableselect',
      '#header'        => $header,
      '#options'       => $options,
      '#empty'         => 'Nincs iskola a listában',
      '#js_select property' => FALSE,
      '#multiple'      => FALSE,
      '#title_display' => "Iskolák táblázata",
      '#attributes'    => array("id"=>"schooltable"),
  );
  
  $form['pager'] = array(
      '#markup' => theme('pager'),
  );
  
  $form['school_id'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Azonosító',
      '#description' => 'Azonosítja az iskolát',
      '#required'    => 'required',
      '#size'        => 20,
      '#maxlength'   => 20,
      '#default_value' => $rowcount==1 ? $r["id"]:''
  );
  
  $form['school_nev'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Iskola neve',
      '#description' => 'Az iskola teljes neve',
      '#required'    => 'required',
      '#size'        => 64,
      '#maxlength'   => 256,
      '#default_value' =>$rowcount ==1 ? $r["nev"]:''
  );
  
  $form['school_user'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Iskolai felhasználó',
      '#description' => 'Létező Drupal felhasználó!<br>Az iskola adatait ő és a rendszer adminisztrátor tudja kezelni',
      '#required'    => 'required',
      '#size'        => 20,
      '#maxlength'   => 20,
      '#default_value' => $rowcount==1 ? $r["user"]:''
  );
  
  $form['school_pwd'] = array(
      '#type'        => 'textfield',
      '#title'       => 'A felhasználó jelszavának változtatása',
      '#description' => 'Létező Drupal felhasználó jelszavának módosítása!<br>Csak a rendszer adminisztrátora és maga a felhasználó tudja móosítani a jelszavát!!!',
      '#required'    => 'required',
      '#size'        => 64,
      '#maxlength'   => 64,
      '#default_value' => $rowcount==1 ? $r["pwd"]:''
  );
  
  $form['school_pwdchange'] = array(
      '#type'  => 'submit',
      '#title' => 'Jelszó módosítás',
      '#name'  => 'password_change',
      '#value' => 'A felhasználó jelszavát módosítja a megadottra',
      '#submit'=> array('fz_form_school_password'),
  );
  
  $form['school_cim'] = array(
      '#type'  => 'textfield',
      '#title' => 'Az iskola címe',
      '#description' => t('Az iskola címe'),
      '#size'        => 64,
      '#maxlength'   => 128,
      '#default_value' => $rowcount==1 ? $r["cim"]:''
  );
  
  $form['school_tel'] = array(
      '#type'  => 'textfield',
      '#title' => 'Telefonszám',
      '#description' => t('Az iskola jelentkezésekkel kapcsolatban felvilágosítást adó telefonszáma'),
      '#default_value' => $rowcount ==1 ? $r["tel"]:''
  );

  $form['school_email'] = array(
      '#type'          => 'textfield',
      '#title'         => 'E-mail',
      '#description'   => t('Az iskola jelentkezéseket fogadó email címe.'),
      '#default_value' => $rowcount==1 ? $r["email"]:''
  );
  if(variable_get("fz_form_teszt"))$form['school_email']['#default_value']= 'iskola@iskola.hu';
  
  $form['school_web'] = array(
      '#type'        => 'textfield',
      '#title'       => 'Honlap',
      '#description' => t('Az iskola honlapja.'),
      '#default_value' => $rowcount==1 ? $r["web"]:''
  );
  
  $form['school_submit'] = array(
      '#title' => 'school_submit',
      '#name'  => 'school_submit',
      '#value' => 'Iskola mentése',
      '#type'  => 'submit',
      '#submit'=> array('fz_form_school_save'),
  );

  $form['school_reset'] = array(
      '#type'  => 'submit',
      '#title' => 'Az űrlapról törli az adatokat',
      '#name'  => 'school_reset',
      '#value' => 'Az űrlapról törli az adatokat',
      '#submit'=> array('fz_form_school_reset'),
      '#limit_validation_errors' => array(),
  );
  
  if(in_array('administrator',$user->roles) || in_array('fz_form_admin', $user->roles))
  $form['school_delete'] = array(
      '#type'  => 'submit',
      '#title' => 'school_delete',
      '#name'  => 'school_delete',
      '#value' => t('A kiválasztott iskola törlése'),
      '#submit'=> array('fz_form_school_delete'),
  );
  return $form;
}

/**
 * Egy iskola adatainak betöltése
 */
function fz_form_school_load(){
    $id = $_REQUEST["id"];
    if(!empty($id)){
      $rs = db_select('fz_form_school','s')
            ->fields('s',array("id","nev","user","pwd","cim", "tel", "email", "web"))
            ->condition('id' , $id , '=' )
            ->execute();
      $row = $rs->fetchAssoc();
    }else{
      $row = array("ID" => "unknown");
    }
    $json = json_encode($row);
    die($json);
}


/**
 * Egy iskola törlése
 * @param array $form
 * @param array $form_state
 */
function fz_form_school_delete(&$form, &$form_state){
  $v  = $form_state['values'];
 
  $db1 = db_select('fz_form_app',"s")
         ->fields('s',array('iskola'))
         ->condition('iskola',$v['school_id'],"=")
         ->execute();
  $err ="";
  if( $db1->rowCount() > 0 ){
    $err .="Az iskolát nem lehet törölni, mert van jelentkezés az iskolába!";
  }
  
  $db2 = db_select('fz_form_conn',"s")
  ->fields('s',array('iskola'))
  ->condition('iskola',$v['school_id'],"=")
  ->execute();
  
  if($db2->rowCount()>0){
    if(!empty($err)) $err .= "<br/>";
    $err .= "Az iskolát nem lehet törölni, mert van meghirdetett oktatása / képzése!";
  }
  
  if(!empty($err)){
    $err = "Az iskola neve: ". $v['school_id'].":<br>".$err;
    drupal_set_message($err,"error");
    return;
  }
    
  $db = db_delete("fz_form_school")
       ->condition('id',$v['school_id'],'=')
       ->execute();
  
  if($db>0){
    drupal_set_message($v['school_id'].': Az iskolát kitöröltük!',"warning");
  }
}

/**
 * Egy iskola adatainak mentése
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_school_save(&$form, &$form_state){
  $v     = $form_state['values'];
  
  if(empty($v['school_nev'])){
    drupal_set_message('Nem lehet üres az iskola címe',"error");
    return ;
  }

  $row = array(
      'id'   => $v['school_id'],
      'nev'  => $v['school_nev'],
      'user' => $v['school_user'],
      'pwd'  => $v['school_pwd'],
      'cim'  => $v['school_cim'],
      'tel'  => $v['school_tel'],
      'email'=> $v['school_email'],
      'web'  => $v['school_web'],
  );
  
  $rs = db_select ("fz_form_school","s")
        ->fields("s",array("id"))
        ->condition('id',$v['school_id'],"=")
        ->execute();
  $db = $rs->rowCount();

  if($db==1){   //Update
    $dbnum = db_update("fz_form_school")
            ->fields($row)
            ->condition('id',$v['school_id'],"=")
            ->execute();
    if($dbnum >0){
      drupal_set_message( $v['school_id'] . ': Az iskola adatai frissültek', "notice" );
    }else{
      drupal_set_message( $v['school_id'] . ': Nem sikerült az iskola adatait frissíteni.' , "error" );
    }
  } else{
    db_insert("fz_form_school")
    ->fields($row)
    ->execute();
    drupal_set_message($v['school_id'].": Az új iskola létrejött. A teljes neve: ".$v['school_nev'], "notice");
  }
  $form_state['rebuild'] = TRUE;
}

/**
 * az isokla űrlapot reseteli
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_school_reset($form, &$form_state){
  $form_state['rebuild'] = False;
}

/**
 * Módosítja az adatbázisban az aktuális felhasználó (iskolai felhasználó) jelszavát
 * @param unknown $form
 * @param unknown $form_state
 */
function fz_form_school_password($form, &$form_state){
  require "includes/password.inc";
  $name = $form_state['values']['school_user'];
  $pwd  = $form_state['values']['school_pwd'];
   
  $user       = user_load_by_name($name);
  $user->pass = user_hash_password($pwd);
  user_save($user);
  $form_state['rebuild'] = TRUE;
  drupal_set_message("Az iskolai felhasználó jelszava megváltozot!!","warning");
 }
 
 /**
  * Keresés az iskolák között
  * @param unknown $form
  * @param unknown $form_state
  */
 function fz_form_school_search($form, &$form_state){
   $form_state['rebuild'] =TRUE;
 }