<?php

function fz_form_settings(){
  $path = drupal_get_path("module", "fz_form");
  drupal_add_css($path. "/fz_form.css","file");
  drupal_add_js($path . '/js/fz_form.js');
  $err = "";
  
  if(!fz_form_check_modules()) return;

  $form = array();
  $form['teszt'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Tesztelés',
      '#collapsible' => FALSE,
  );
  $form['teszt']['fz_form_teszt'] = array(
    '#type'          => 'checkbox',
    '#title'         => 'Automatikus tesztadatok használata',
    '#required'      => FALSE,
    '#default_value' => variable_get('fz_form_teszt',False),
    '#description'   => "Automatikus tesztadatokkal lehet tesztelni a rendszert.",
  );
  if(variable_get('fz_form_teszt')){
    $form['teszt']['fz_form_iskola'] =array(
        '#type' => 'textfield',
        '#title'         => 'A tesztelés során a bejelentkezett felhasználó csak a megadott iskola adataihoz fér hozzá',
        '#default_value' => variable_get('fz_form_iskola',''),
        '#description'   => 'Teszt iskola',
        '#size'          => 64,
        '#maxlength'     => 64,
    );
  }

  $form['fz_form_closed'] = Array(
	'#type'          => 'checkbox',
	'#title'         => 'Jelentkezesi felület zárva',
	'#default_value' => variable_get('fz_form_closed', false),
	'#description'   => 'Le lehet kapcsolni külső felhasználók részére a jelentkezési felületet',
  );

  $form['mail_to_school'] = array(
      '#type'   => 'fieldset',
      '#title'  => 'Email az iskolának',
      '#collapsible' => FALSE,
  );
  
  $form['mail_to_school']['fz_form_mail_to_school'] = array(
      '#type'          => 'checkbox',
      '#title'         => 'Email küldése az iskolának',
      '#required'      => FALSE,
      '#default_value' => variable_get('fz_form_mail_to_school',False),
      '#description'   => "A jelentkezésről és a jelentkezés visszaigazolásáról levél megy az iskolának is.",
  );
  
  if(variable_get('fz_form_mail_to_school',False)){
    $form['mail_to_school']['fz_form_mail_to_school_from'] = array(
      '#type'          => 'textfield',
      '#title'         => 'A levél feladója',
      '#size'          => 64,
      '#maxlength'     => 64,
      '#required'      => FALSE,
      '#default_value' => variable_get('fz_form_mail_to_school_from',FZ_FORM_DEFAULT_SENDER_MAIL),
      '#description'   => "A visszaigazoló levél feladója.",
    );
  }
  
  $file_public_path = variable_get("file_public_path");
  $fz_form_doc      = variable_get('fz_form_doc',FZ_FORM_DOC);
  $form['fz_form_pdf'] = array(
      '#type'          => 'textfield',
      '#title'         => 'A jelentkezési lapok (pdf) mentéséhez használt mappa',
      '#default_value' => $fz_form_doc,
      '#description'   => 'A jelentkezési lapok tárolási helye:<b>"'.$file_public_path.'/'.$fz_form_doc.'/{iskola}"</b>.',
      '#size'          => 64,
      '#maxlength'     => 64,
      '#required'      => 'required',
  );
  

  $fz_form_excel         = variable_get('fz_form_excel',FZ_FORM_EXCEL);
  $form['fz_form_excel'] = array(
      '#type'          => 'textfield',
      '#title'         => 'A mentett Excel fájlok (.xlsx) mentéséhez használt mappa',
      '#default_value' => $fz_form_excel,
      '#description'   => 'A mentett excel fájlok tárolási helye:<b>"'.$file_public_path.'/'.$fz_form_excel.'/{iskola}"</b>.',
      '#size'          => 64,
      '#maxlength'     => 64,
      '#required'      => 'required',
  );
  
  $form["exists"] = array(
      '#markup' => '<p>Felhasználók létezésének ellenőrzése, jelszavak módosítása: <a href="../../../admin/people" target="_blank">Felhasználók létezésének ellenőrzése / jelszavak módosítása</a></p>',
  );
  $form['usersok'] = array(
      '#markup'=> '<p>Ha nincsenek meg az intézményi felhasználók, akkor alapértelmezésként létrehozza őket!</p>',
  );
   
  $form['makeusers'] = array(
      '#type'   => 'submit',
      '#title'  => 'makeusers',
      '#name'   => 'makeusers',
      '#value'  => 'Felhasználók lérehozása',
      '#submit' => array('fz_form_makeusers'),
  );
  
  $kezdes = "2016/2017\n2016/2017 keresztfélév\n2017/2018\n2017/2018 keresztfélév\n2018/2019\n2018/2019 keresztfélév\n2019/2020\n2019/2020 keresztfélév\n2020/2021\n2020/2021 keresztfélév";
  
  $form['fz_form_kezdes'] = array(
    '#type'          =>'textarea',
    '#title'         => 'A tanévek listája, amikorra lehet jelentkezni',
    '#default_value' => variable_get('fz_form_kezdes',$kezdes),
    '#description'   => "A tanévek listája, amikorra lehet jelentkezni. Soronként egy oktatási / képzés indulási időpont.",
    '#cols'          => 40,
    '#rows'          => 5,
  );

  $forma ="nappali\nfelnőtt esti\nlevelező\ntanfolyam";
  $form['fz_form_forma'] = array(
    '#type'          => 'textarea',
    '#title'         => 'A képzési formák',
    '#default_value' => variable_get('fz_form_forma',$forma),
    '#description'   => "A képzési formák felsorolása. Soronként egy oktatási / képzési forma.",
    '#cols'          => 40,
    '#rows'          => 5,
  );
  
  $status = FZ_FORM_STATUS_DEFAULT."\n"
           .FZ_FORM_STATUS_EMAIL."\n"
           .FZ_FORM_STATUS_CONFIRM."\n"
           .FZ_FORM_STATUS_OK."\n"
           .FZ_FORM_STATUS_ELUTASITVA."\n"
           .FZ_FORM_STATUS_BEIRATKOZVA;
  
  $form['fz_form_status'] = array(
      '#type'          => 'textarea',
      '#title'         => 'Jelentkezés állapota',
      '#default_value' => $status,
      '#description'   => "A jelentkezések állapota. Soronként egy állapot.",
      '#cols'          => 40,
      '#rows'          => 5,
      '#attributes'    => array('disabled' =>'disabled'),
  );
  
  $mail_text = variable_get('fz_form_mail_to_app','');
  if(empty($mail_text)){
    variable_set('fz_form_mail_to_app', FZ_FORM_MAIL_TO_APP);
    $mail_text = variable_get('fz_form_mail_to_app','');
  }
  $form['fz_form_mail_to_app'] = array(
      '#type'          => 'textarea',
      '#title'         => 'Küldendő email szövege',
      '#default_value' => variable_get('fz_form_mail_to_app',$status),
      '#description'   => "A jelentkezőknek küldendő értesítés a beiratkozás időpontjáról.",
      '#cols'          => 40,
      '#rows'          => 5,
  );
  
  $form = system_settings_form($form);
 
  return $form;
}

/*
 * Ellenőrzi, hogy megvannak-e a telepítendő modulok
 */

function fz_form_check_modules(){
  $err ="";
  if(!module_exists('print')){
    $err .='- Hiányzik a "Printer-friendly pages" (print) modul. Szóljon az üzemeltetőnek, hogy telepítse!<br/>Letöltése innen: https://www.drupal.org/project/print<br/><br/>';
  }
  
  if(!module_exists('print_pdf')){
    $err .='- Hiányzik a Printer-friendly pages"PDF Version" (print_pdf) modul. Szóljon az üzemeltetőnek, hogy telepítse! <br/>(Ha a "print" modul telepítve van, akkor nem kell letölteni semmit, csak engedélyezni!)<br/><br/>';
  }
  
  if(!module_exists('print_mail')){
    $err .='- Hiányzik a "Send by email"(print_mail) modul. Szóljon az üzemeltetőnek, hogy telepítse!<br/>(Ha a "print" modul telepítve van, akkor nem kell letölteni semmit, csak engedélyezni!)<br/><br/>';
  }
  
  if(!empty($err)){
    drupal_set_message($err, "error");
  }
  return empty($err);
}