<?php
/**
 * Felhasználókkal kapcsolatos függvények
 */

/**
 * Létrehozza a modulhoz tartozó default felhasználókat
 */
function fz_form_makeusers(){
  require "includes/password.inc";

  //fz form_admin szerepkör létrehozása, ha nincsen még meg
  $roleadmin = user_role_load_by_name(FZ_FORM_ADMIN);
  if(!$roleadmin){
    $roleadmin = new stdClass();
    $roleadmin->name = FZ_FORM_ADMIN;
    user_role_save($roleadmin);
    $roleadmin = user_role_load_by_name(FZ_FORM_ADMIN);
  }
  $ridadmin = (int) $roleadmin->rid;
  //fz_form szerepkör létrehozása
  $role = user_role_load_by_name(FZ_FORM_ROLE);
  if(!$role){
    $role = new stdClass();
    $role->name = FZ_FORM_ROLE;
    user_role_save($role);
    $role = user_role_load_by_name(FZ_FORM_ROLE);
  }
  $rid = (int)($role->rid);

  // Default userek létrehozása
  $rs = db_select('fz_form_school','s')
  ->fields('s',array('user', 'email','pwd'))
  ->execute();
  $records = $rs->fetchAll(PDO::FETCH_ASSOC);
  //
  foreach($records As $i => $u){
    $user = user_load_by_name($u['user']);
    if(!$user){
      $account = new stdClass;
      $account->is_new = TRUE;
      $account->name   = $u['user'];
      $account->pass   = user_hash_password($u['pwd']);

      $account->mail   = $u['email'];
      $account->init   = $u['email'];
      $account->status = TRUE;
      if($account->name != "BGSZC"){
        $account->roles = array(
          DRUPAL_AUTHENTICATED_RID => TRUE,
          $rid                     => FZ_FORM_ROLE
        );
      }
      else{
        $account->roles = array(
            DRUPAL_AUTHENTICATED_RID => TRUE,
            $rid                     => FZ_FORM_ROLE,
            $ridadmin                => FZ_FORM_ADMIN
        );
      }
      $account->timezone = variable_get('date_default_timezone', '');
      user_save($account);
      drupal_set_message("Létrehozott új felhasználó: Felhasználói név: <b>".$u['user']."</b>, email: <b>".$u['email']."</b>, Alapértelmezett jelszó: ".$u['user']."123", "warning");
    }else{
      $msg = "A felhasználói név: <b>".$u['user']."</b>, email:<b> ". $u['email']."</b> már létezik! ";
      //Ha a usernek nincsen meg a szerepe
      if(!isset($user->roles[$rid])){
        $user->roles = $user->roles + array($rid => FZ_FORM_ROLE);
        user_save($user);
        $msg .= "<br/>Hozzáadtuk a felhasználóhoz az alábbi hatókört: <b>'".FZ_FORM_ROLE."'</b>";
      }
      if($user->name == "bgszc" && !isset($user->roles[$ridadmin])){
        $user->roles = $user->roles + array($ridadmin => FZ_FORM_ADMIN);
        user_save($user);
      }
      drupal_set_message($msg, "error");
    }
  }
}

/**
 * Törli a modulhoz tartozó default felhasználókat
 */
function fz_form_delusers(){
  //userek törlése
  $rs = db_select('fz_form_school','s')
  ->fields('s',array('user'))
  ->execute();
  $records = $rs->fetchAll(PDO::FETCH_ASSOC);
  foreach($records As $i => $u){
    $user = user_load_by_name($u['user']);
    user_delete($user->uid);
  }
  //role törlése
  user_role_delete(FZ_FORM_ROLE);
  user_role_delete(FZ_FORM_ADMIN);
  drupal_set_message("Töröltük az 'FZ_FORM module' default felhasználóit és az 'fz_form' szerepkört!",'warning');
}

/**
 * Az aktuális felhasználót lekérdezem az iskolájáról
 */
function fz_form_user_iskola(){
  global $user;
  if(variable_get('fz_form_teszt')){
    $iskola = variable_get('fz_form_iskola');
    if(empty($iskola)) $iskola = FALSE;
  }else{
    $rs = db_query('select id FROM {fz_form_school} WHERE user = :1',array(':1' => $user->name));
    $iskola = $rs->fetchAssoc('id');
  }
  return $iskola;
}

function fz_form_permission(){
  global $user;
  
  if(in_array('administrator',$user->roles) || in_array(FZ_FORM_ADMIN,$user->roles) ){
    return FZ_FORM_ADMIN;
  }
  if(in_array('FZ_FORM',$user->roles)){
    return FZ_FORM;
  }
  if(in_array('authenticated user',$user->roles)){
    return AUTHENTICATED_USER;
  }
  return ANONYMOUS_USER;
}